﻿using System;
using System.ComponentModel;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace ClinSchd.Infrastructure.Converters
{
    public class BooleanToVisibilityCollapsedConverter : IValueConverter
    {
        public static BooleanToVisibilityCollapsedConverter Default = new BooleanToVisibilityCollapsedConverter();

        public virtual object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if ( IsInDesignMode )
                return Visibility.Visible;

            var boolean = false;
            if (value is bool) boolean = (bool)value;
            return boolean ? Visibility.Visible : Visibility.Collapsed;
        }

        public virtual object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value is Visibility && (Visibility)value == Visibility.Visible;
        }

        private bool IsInDesignMode
        {
            get { return DesignerProperties.GetIsInDesignMode( new DependencyObject() ); }
        }
    }
}
