﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Data;

namespace ClinSchd.Infrastructure.Converters
{
    public class InverseBooleanToVisibilityCollapsedConverter : IValueConverter
    {
        public static InverseBooleanToVisibilityCollapsedConverter Default = new InverseBooleanToVisibilityCollapsedConverter();

        public virtual object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var boolean = false;
            if (value is bool) boolean = (bool)value;
            return boolean ? Visibility.Collapsed : Visibility.Visible;
        }

        public virtual object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value is Visibility && (Visibility)value == Visibility.Collapsed;
        }
    }
}
