﻿using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Presentation.Events;

using ClinSchd.Infrastructure.Models;
using System;

namespace ClinSchd.Infrastructure
{
    public struct CancelApptDialogEventPayload
    {
        public CancelApptDialogEventPayload(SchdAppointment apptToCancel, Action<bool> callback)
            : this()
        {
            ApptToCancel = apptToCancel;
            Callback = callback;
            AddToWaitList = true;
        }

        public CancelApptDialogEventPayload(SchdAppointment apptToCancel, Action<bool> callback, bool addToWaitList)
            : this(apptToCancel, callback)
        {
            AddToWaitList = addToWaitList;
        }

        public SchdAppointment ApptToCancel { get; private set; }
        public Action<bool> Callback { get; private set; }
        public bool AddToWaitList { get; set; }
    }

	public class LaunchCancelApptDialogEvent : CompositePresentationEvent<CancelApptDialogEventPayload>
	{
	}
}
