﻿using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Presentation.Events;

using ClinSchd.Infrastructure.Models;
using System;

namespace ClinSchd.Infrastructure.Events
{
    public class LaunchMRTCCancelDialogArgs
    {
        public LaunchMRTCCancelDialogArgs(AppointmentRequest request, SchdAppointment appointment, string selectedClause, Action<bool> callback)
        {
            Request = request;
            Appointment = appointment;
            Callback = callback;
            SelectedClause = selectedClause;
        }

        public Action<bool> Callback { get; private set; }

        public AppointmentRequest Request { get; private set; }

        public SchdAppointment Appointment { get; private set; }

        public bool IsCancelAppointment { get { return (Appointment != null); } }

        public bool IsCancelRequest { get { return (Request != null); } }

        public string SelectedClause { get; private set; }
    }

    public class LaunchMRTCCancelDialog : CompositePresentationEvent<LaunchMRTCCancelDialogArgs>
    {
    }
}
