﻿using System.Windows;
using Microsoft.Practices.Composite.Presentation.Events;

using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Infrastructure.Events
{
    public class PatientDisabilitiesArgs
    {
        public Window Owner { get; private set; }
        public Patient Patient { get; private set; }

        public PatientDisabilitiesArgs(Window owner, Patient patient)
        {
            this.Owner = owner;
            this.Patient = patient;
        }
    }

    // The Window object is required to display the Patient Disabilities dialog
    // Pass null as the Window object to close the Patient Disabilitiesa Window
    public class PatientDisabilitiesEvent : CompositePresentationEvent<PatientDisabilitiesArgs>
    {
    }
}
