﻿using ClinSchd.Infrastructure.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;

namespace ClinSchd.Infrastructure.Factories
{
    public class PatientContactFactory
    {

        public static PatientContact CreatePatientContact(string sdecDisplayRpc)
        {
            var rpcPieces = getRpcPieces(sdecDisplayRpc); 

            if (rpcPieces.Length != 6)
                return null;           

            return createPatientContact(rpcPieces);
        }

        #region HELPERS
        private static string[] getRpcPieces(string rpcString)
        {
            if (string.IsNullOrWhiteSpace(rpcString))
                return new string[0];

            return rpcString.Split('^');
        }
        private static PatientContact createPatientContact(string[] rpcPieces)
        {
            var patientContact = new PatientContact(); 
            return mapPatientContact(patientContact, rpcPieces);
        }
                private static PatientContact mapPatientContact(PatientContact patientContact, string[] rpcPieces)
                {
                    patientContact.PatientContactFileIen = FactoryUtilities.IntParser(rpcPieces[0]);
                    patientContact.PatientIen = FactoryUtilities.IntParser(rpcPieces[1]);
                    patientContact.ClinicIen = FactoryUtilities.IntParser(rpcPieces[2]);
                    patientContact.CidPreferredDate = ExtensionMethods.ConvertFromFilemanDateTime(rpcPieces[3]);
                    patientContact.RequestType = rpcPieces[4];
                    patientContact.MainSequence = FactoryUtilities.IntParser(rpcPieces[5]);
                    return patientContact; 
                }        
        #endregion
        
    }
}
