﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Shapes;

using Telerik.Windows.Controls;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Infrastructure
{
    public static class Keys
    {
        public static CCOWBase CCOW;
        public static string CCOWToken;
        public static string CCOWDomainName;
        public static string CCOWDomainIEN;
        public static bool CCOWEnabled;

        public static bool HavePatientData;

        public static bool SendPatientData;

        public static bool DisplayAmieCandPPrompts;

        public static int ClinSetSearchCharMin = 2;
        public static int ClinStopSearchCharMin = 2;
        public static int ClinicResourceSearchCharMin = 2;
        public static int ClinicHResourceSearchCharMin = 2;
        public static int ClinicResourceSearchMaxRecords = 50;
        public static int ClinicResourceSearchGetNextWithin = 8;
        public static int PatientSearchCharMin = 3;

        public static int ProviderSearchCharMin = 3;
        public static int ProviderSearchMaxRecords = 50;
        public static int ProviderSearchGetNextWithin = 8;
        public static int NewAppointmentMaxDuration = 240;
        public static bool EnableScheduleDragAndDrop = false;

        public static IList<string> SdecResourceParms;
        public static DataTable SdecResourceData;
        public static SlotsAvailable AppointmentSlots { get; set; }
        public static string ApplicationVersion { get; set; }
        public static double SearchTimerInterval = 1000;
        public static readonly int MaxPatientsToReturn = Convert.ToInt32(System.Configuration.ConfigurationManager.AppSettings["MaxPatientsToReturn"]);
        public static readonly string CCOWHost = System.Configuration.ConfigurationManager.AppSettings["CCOWHost"];
        public static readonly int CCOWPort = Convert.ToInt32(System.Configuration.ConfigurationManager.AppSettings["CCOWPort"]);
        public static readonly string CCOWNSpace = System.Configuration.ConfigurationManager.AppSettings["CCOWNSpace"];
        public static IList<CHoliday> Holidays { get; set; }
        public static bool IsAddAppointmentOrLeftClickOnScheduler { get; set; }  //flag to bypass display increment changing on the fly.. due to appointment start times.. bj_10_13_2015

        public static class RMGridDefaultColumnOrder
        {
            public const string REQUEST_TYPE = "REQUEST TYPE";
            public const string WAIT_TIME = "WAIT TIME";
            public const string PT_NAME = "PT NAME";
            public const string MRTC = "MRTC";
            public const string SSN = "SSN";
            public const string SCVISIT = "SCVISIT";
            public const string TELEPHONE = "TELEPHONE";
            public const string PRIORITY = "PRIORITY";
            public const string CID_PREFERRED_DATE = "CID/PREFERRED DATE";
            public const string ENTERED_RR_NO_DATE = "ENTERED/RR NO DATE";
            public const string REQUESTOR = "REQUESTOR";
            public const string REQUESTED_BY = "REQUESTED BY";
            public const string CLINIC_SERVICE = "CLINIC/SERVICE";
            public const string COMMENT = "COMMENT";

            public static List<string> ToList()
            {
                return new List<string>()
                {
                    REQUEST_TYPE,
                    WAIT_TIME,
                    PT_NAME,
                    MRTC,
                    SSN,
                    SCVISIT,
                    TELEPHONE,
                    PRIORITY,
                    CID_PREFERRED_DATE,
                    ENTERED_RR_NO_DATE,
                    REQUESTOR,
                    REQUESTED_BY,
                    CLINIC_SERVICE,
                    COMMENT
                };
            }
        }

        public static UserPreferences UserPreferences { get; set; } = new UserPreferences();
        public static List<string> UserPrefList { get; set; } = new List<string>();

        public static bool VARWebServiceConfigured
        {
            get
            {
                var url = System.Configuration.ConfigurationManager.AppSettings["var_service_url"];

                if (string.IsNullOrEmpty(url))
                    return false;
                return url.Contains("/VSE_VAR_Service") || url.Contains("/VSE");
            }
        }
        public static class PatientContactActions
        {
            public static string LeftMessage             = "Left Message";
            public static string NoAnswer                = "No Answer";
            public static string NumberNoLongerInService = "Number No Longer In Service";
            public static string ContactMade             = "Contact Made";
            public static string Letter                  = "Letter";
            public static string ContactAttempt1         = "Call Attempt 1";
            public static string ContactAttempt2         = "Call Attempt 2";
            public static string ContactAttempt3         = "Call Attempt 3";
            public static string LetterSent              = "Letter Sent to Patient";
        }

        public static class Mrtc
        {
            public static string FirstBookedDate { get; set; }
        }
        public static string LastRecordUnlocked { get; set; }
        public static bool IsEwlTransfer { get; set; }
        public static string UsersTempFolder = "Vista Scheduling";
        public static class JasperReportFiles
        {
            public static readonly List<string> JasperFiles = new List<string> { "SDEC_VSE.XML", "SDEC_VSE_ReportConsole.jar", "SDEC_VSE_ReportTemplate.jasper", "SDEC_VSE_ReportTemplate.jrxml", "TotalDemandCharts.jrxml", "TotalDemandSupplyCharts.jrxml", "TotalSupplyCharts.jrxml" };
        }
        public static string MrtcCloseRequestIen { get; set; }
        public static string MaxWaitListRecordsToReturn = "25";
        public static string WaitListQueryLastRec { get; set; }

        public static int WaitListQueryTotalRecords { get; set; }

        public static string WaitListCurrentFilter { get; set; }
        public static string QueryFormCurrentFilter { get; set; }
        public static string WaitListQueryType { get; set; }
        public static int RPCExecutingCount = 0;
        public static class WaitListQueryTypes
        {
            public static string InitialPull = "InitialPull";
            public static string SelectPatient = "SelectPatient";
            public static string ServerQuery = "ServerQuery";
        }


        public static string AppointmentLengthValidationErrorMsg = "Please type a Number between 10 and 120, 0 Decimal Digits for Appointment Length";
        public static string InvalidClinicRequestMessage = "Please select a clinic or service for this request";
        public static Window MainWindow { get; set; }
        public static string TraceSessionId { get; set; }
        public static string LoggedInUser { get; set; }
        public static string LoggedInUserIen { get; set; }
        public static string LoggedInUserAccessCode { get; set; }
        public static string LoggedInUserVerifyCode { get; set; }
        public static bool LoggedInUserMasterOverbook { get; set; }
        public static bool LoggedInUserRegularOverbook { get; set; }
        public static bool LoggedInUserSDWLMenuKey { get; set; }
        public static bool LoggedInUserSDECViewOnlyKey { get; set; }
        public static bool IsCallCenterUser { get; set; }
        public static string ScheduleRequestType { get; set; }
        public static bool IsAvailabilitySearch { get; set; }
        public static string Availability = "AVAILABILITY";
        public static int PrerequisiteWindowRequestIen { get; set; }

        public static string DefaultFacilityFontSize { get; set; }
        public static ServerPrinter SelectedServerPrinter { get; set; }

        public static string[] SignonResponse { get; set; }

        public static class Categories
        {
            public static string New_Appointment          = "NewAppointmentCategory";
            public static string WalkIn_Appointment       = "WalkInAppointmentCategory";
            public static string Cancelled_Appointment    = "CancelledAppointmentCategory";
            public static string NoShow_Appointment       = "NowShowAppointmentCategory";
            public static string CheckedIn_Appointment    = "CheckedInAppointmentCategory";
            public static string CheckedOut_Appointment   = "CheckedOutAppointmentCategory";
            public static string Holiday_Event            = "HolidayEventCategory";
            public static string VariableLength_Event     = "VariableLengthEventCategory";
            public static string SpecialInstructionsEvent = "SpecialInstructionsCategory";
        }

        public static class SlotCategoryNames
        {
            public static string AllDaySlot                       = "AllDaySlot";
            public static string NonWorkingSlot                   = "NonWorkingSlot";
            public static string UnavailableSlot                  = "UnavailableSlot";
            public static string AvailableSlot                    = "AvailableSlot";
            public static string CancelledAvailabilitySlot        = "CancelledAvailabilitySlot"; 
            public static string HolidayUnavailableSlot           = "HolidayUnavailableSlot";
            public static string HolidayAvailableSlot             = "HolidayAvailableSlot";
            public static string HolidayNotWorkingSlot            = "HolidayNotWorkingSlot";
            public static string HolidayCancelledAvailabilitySlot = "HolidayCancelledAvailabilitySlot";
        }

        public static class ColorCodes
        {
            public static readonly Brush HatchedBrushFontColor                  = Brushes.Black;
            public static readonly Brush NewAppointmentColor                    = new SolidColorBrush(Color.FromArgb(255, 181, 138, 165)); // Brushes.White;
            public static readonly Brush WalkInAppointmentColor                 = new SolidColorBrush(Color.FromArgb(255, 159, 186, 216));
            public static readonly Brush CancelledAppointmentColor              = Brushes.Gray;
            public static readonly Brush NoShowColor                            = new SolidColorBrush(Color.FromArgb(255, 228, 0, 27)); //Brushes.Pink;
            public static readonly Brush CheckedInColor                         = Brushes.Yellow;
            public static readonly Brush CheckedOutColor                        = Brushes.Orange;
            public static readonly Brush HolidayNotWorkingColor                 = Brushes.DarkCyan;
            public static readonly Brush HolidayAvailableColor                  = Brushes.White; // Brushes.LightCyan;
            public static readonly Brush HolidayUnavailableColor                = new SolidColorBrush(Color.FromArgb(255, 0, 102, 102)); //Brushes.Cyan;
            public static readonly Brush VariableLengthApptColor                = Brushes.Khaki;
            public static readonly Brush SpecialInstructionsColor               = Brushes.Yellow;
            public static readonly Brush AvailableSlotColor                     = Brushes.White;
            public static readonly Brush AvailableSlotBorderColor               = new SolidColorBrush(Color.FromArgb(255, 43, 43, 43));
            public static readonly Brush UnavailableSlotColor                   = new SolidColorBrush(Color.FromArgb(255, 0, 102, 102)); // Brushes.DarkGray;
            public static readonly Brush NonWorkingSlotColor                    = new SolidColorBrush(Color.FromArgb(255, 51, 51, 51)); // Brushes.Gray;
            public static readonly Brush CancelledAvailabilitySlotColor         = GetHatchBrush(UnavailableSlotColor as SolidColorBrush);
            public static readonly Brush HolidayCancelledAvailabilitySlotColor  = GetHatchBrush(UnavailableSlotColor as SolidColorBrush); //GetHatchBrush(HolidayUnavailableColor as SolidColorBrush);
            public static readonly Brush AllDayEventAreaColor                   = Brushes.MediumPurple;
            public static readonly Brush AvailableSlotsAreaColor                = Brushes.LightBlue;
            public static readonly Brush InactiveClinicBackgroundColor          = Brushes.Red;
            public static readonly Brush InactiveClinicForegroundColor          = Brushes.White;
            
            public static readonly Dictionary<string, Brush> CategoriesList = new Dictionary<string, Brush>
            {
                { Categories.New_Appointment, NewAppointmentColor },
                { Categories.WalkIn_Appointment, WalkInAppointmentColor },
                { Categories.Cancelled_Appointment, CancelledAppointmentColor },
                { Categories.NoShow_Appointment, NoShowColor },
                { Categories.CheckedIn_Appointment, CheckedInColor },
                { Categories.CheckedOut_Appointment, CheckedOutColor },
                { Categories.Holiday_Event, HolidayNotWorkingColor },
                { Categories.SpecialInstructionsEvent, SpecialInstructionsColor },
                { Categories.VariableLength_Event, VariableLengthApptColor }
            };

            public static readonly Dictionary<string, Brush> SlotCategoriesList = new Dictionary<string, Brush>
            {
                { SlotCategoryNames.AllDaySlot, AllDayEventAreaColor},
                { SlotCategoryNames.NonWorkingSlot, NonWorkingSlotColor},
                { SlotCategoryNames.UnavailableSlot, UnavailableSlotColor},
                { SlotCategoryNames.AvailableSlot, AvailableSlotColor},
                { SlotCategoryNames.CancelledAvailabilitySlot, CancelledAvailabilitySlotColor},
                { SlotCategoryNames.HolidayNotWorkingSlot, NonWorkingSlotColor }, //HolidayNotWorkingColor},
                { SlotCategoryNames.HolidayUnavailableSlot, HolidayUnavailableColor},
                { SlotCategoryNames.HolidayAvailableSlot, HolidayAvailableColor},
                { SlotCategoryNames.HolidayCancelledAvailabilitySlot, HolidayCancelledAvailabilitySlotColor }
            };

            public static readonly List<string> NonMenuedSlotCategories = new List<string>
            {
                SlotCategoryNames.AllDaySlot,
                SlotCategoryNames.NonWorkingSlot,
                SlotCategoryNames.CancelledAvailabilitySlot,
                SlotCategoryNames.HolidayNotWorkingSlot,
                SlotCategoryNames.HolidayCancelledAvailabilitySlot
            };

            private static Dictionary<string, Category> _appointmentCategories;

            public static Dictionary<string, Category> AppointmentCategories
            {
                get
                {
                    if (_appointmentCategories == null)
                    {
                        _appointmentCategories = new Dictionary<string, Category>();

                        foreach (var item in CategoriesList)
                        {
                            string displayName = string.Empty;

                            if (item.Key == Categories.New_Appointment)
                                displayName = "New";
                            else if (item.Key == Categories.WalkIn_Appointment)
                                displayName = "Walk-In";
                            else if (item.Key == Categories.Cancelled_Appointment)
                                displayName = "Cancelled";
                            else if (item.Key == Categories.NoShow_Appointment)
                                displayName = "No Show";
                            else if (item.Key == Categories.CheckedIn_Appointment)
                                displayName = "Checked In";
                            else if (item.Key == Categories.CheckedOut_Appointment)
                                displayName = "Checked Out";

                            _appointmentCategories.Add(item.Key, new Category(item.Key, item.Value) { DisplayName = displayName });
                        }
                    }
                    return _appointmentCategories;
                }
            }

            private static Dictionary<string, Category> _slotCategories;

            public static Dictionary<string, Category> SlotCategories
            {
                get
                {
                    if (_slotCategories == null)
                    {
                        _slotCategories = new Dictionary<string, Category>();

                        foreach (var item in SlotCategoriesList)
                            _slotCategories.Add(item.Key, new Category(item.Key, item.Value));
                    }

                    return _slotCategories;
                }
            }

            private static VisualBrush GetHatchBrush(byte r, byte g, byte b)
            {
                return GetHatchBrush(new SolidColorBrush(Color.FromRgb(r, g, b)));
            }

            private static VisualBrush GetHatchBrush(SolidColorBrush fillBrush)
            {
                try
                {
                    var hatchBrush = new VisualBrush
                    {
                        Viewport = new Rect( 0, 0, 10, 10 ),
                        Viewbox = new Rect( 0, 0, 10, 10 ),
                        ViewportUnits = BrushMappingMode.Absolute,
                        ViewboxUnits = BrushMappingMode.Absolute,
                        TileMode = TileMode.Tile
                    };
                    var visual = new Canvas();
                    var rect = new Rectangle
                    {
                        Fill = fillBrush,
                        Width = 10,
                        Height = 10
                    };
                    var stroke = new Path
                    {
                        Stroke = new SolidColorBrush( Colors.Black ),
                        Data = Geometry.Parse( "M 0 0 l 10 10" )
                    };

                    visual.Children.Add(rect);
                    visual.Children.Add(stroke);
                    hatchBrush.Visual = visual;
                    return hatchBrush;
                }
                catch (Exception ex)
                {
                    TraceLog.LogInfo(ex.Source, ex.GetType().ToString(), ex.Message);
                    //MessageBox.Show(ex.Source + ": " + ex.Message);
                    return null;
                }
            }
        }

        public static class AccessTypes
        {
            public static string Available { get; set; }
            public static string Cancelled { get; set; }
            public static string Unavailable { get; set; }
        }

        public static IList<TimeScaleModel> TimeScaleList
        {
            get
            {
                IList<TimeScaleModel> list = new List<TimeScaleModel>();
                var idx = 0;

                for (var t = 10; t <= NewAppointmentMaxDuration; t += 5)
                    if (t % 10 == 0 || t % 15 == 0)
                        list.Add(new TimeScaleModel(idx++, t.ToString()));

                return list;
            }
        }

        public static AppointmentRequest SelectedAppointmentRequest { get; set; }
        public static AppointmentRequest SelectedPatientAppointmentRequest { get; set; }
        public static RPMSClinic SelectedClinic { get; set; }
        public static bool SameClinicSelected { get; set; }

        private static Patient selectedPatient; 
        public static Patient SelectedPatient {
            get
            {
                return selectedPatient; 
            }
            set
            {
                if (value == null)
                    closePrerequisitesWindows(); 
                else
                    if (selectedPatient != null && selectedPatient.IEN != value.IEN)
                            closePrerequisitesWindows();
                                
                selectedPatient = value; 
            }
        }

        public static void closePrerequisitesWindows()
        {
            var windows = Application.Current.Windows;
            foreach (Window w in windows)
                if (w.Title.ToLower() == "prerequisites")
                    w.Close();
        }

        public static string PatientIen_SensitiveRecordCheck { get; set; } = null;
        public static DateTime? SelectedAppointmentInitialDesiredDate { get; set; }
        public static bool RemoveConsultRequest { get; set; }

        public class AppointmentRequestTypes
        {
            public const string PtCSch      = "PtCSch";
            public const string Ewl         = "EWL";
            public const string Consult     = "CONSULT";
            public const string Procedure   = "PROCEDURE";
            public const string Appt        = "APPT";
            public const string Veteran     = "VETERAN";
            public const string Mobile      = "MOBILE";
            public const string WelcomeToVa = "W2VA";
            public const string ReturnToClinic = "RTC";
        }

        public static string AppointmentRequestTypeFromFirstLetter(string firstLetter)
        {
            switch (firstLetter)
            {
                case "R":
                    return Keys.AppointmentRequestTypes.PtCSch;
                case "E":
                    return Keys.AppointmentRequestTypes.Ewl;
                case "C":
                    return Keys.AppointmentRequestTypes.Consult;
                case "P":
                    return Keys.AppointmentRequestTypes.Procedure;
                case "A":
                    return Keys.AppointmentRequestTypes.Appt;
                case "V":
                    return Keys.AppointmentRequestTypes.Veteran;
                case "M":
                    return Keys.AppointmentRequestTypes.Mobile;
                case "W":
                    return Keys.AppointmentRequestTypes.WelcomeToVa;
            }

            return string.Empty;
        }

        public static string AppointmentRequestTypeCode(string appointmentRequestType)
        {
            switch (appointmentRequestType)
            {
                case AppointmentRequestTypes.PtCSch:
                    return "R";
                case AppointmentRequestTypes.Ewl :
                    return "E";
                case AppointmentRequestTypes.Consult :
                    return "C";
                case AppointmentRequestTypes.Procedure :
                    return "P";
                case AppointmentRequestTypes.Appt :
                    return "A";
                case AppointmentRequestTypes.Veteran:
                    return "V";
                case AppointmentRequestTypes.Mobile :
                    return "M";
                case AppointmentRequestTypes.WelcomeToVa :
                    return "W";
                case AppointmentRequestTypes.ReturnToClinic:
                    return "RTC";
            }

            return string.Empty;
        }

        public static class AppointmentGroupNames
        {
            public const string Appointment = "Appointment";
            public const string SpecialInstructions = "SpecialInstructions";
        }

        public static class Tables
        {
//            public static DataTable AllResourceTable { get; set; }
            public static DataTable ProviderResourceTable { get; set; }
//            public static IList<Provider> AllProviders { get; set; }
            public static DateTime ClinAllDataLoaded = DateTime.MinValue;
            public static DataTable ClinAllData { get; set; }
            public static DateTime PatientPrefsLoaded = DateTime.MinValue;
            public static string PatientPrefsIEN = string.Empty;
            public static DataTable PatientPrefs { get; set; }
            public static DateTime PtCSchApptTypesDataLoaded = DateTime.MinValue;
            public static DataTable PtCSchApptTypesData { get; set; }
            public static DateTime ResourceGroupDataLoaded = DateTime.MinValue;
            public static DataTable ResourceGroupData { get; set; }
            public static DateTime ResourceGroupListDataLoaded = DateTime.MinValue;
            public static DataTable ResourceGroupListData { get; set; }
            public static DateTime ServiceSpecialtyDataLoaded = DateTime.MinValue;
            public static DataTable ServiceSpecialtypData { get; set; }

            public static readonly Dictionary<string, DataTableCache> PatientTableCache = new Dictionary<string, DataTableCache>();
            public static readonly Dictionary<string, DataTableCache> FutureApptsTableCache = new Dictionary<string, DataTableCache>();
            public static readonly Dictionary<string, DataTableCache> LookupTablesCache = new Dictionary<string, DataTableCache>();
            public static readonly Dictionary<string, DataTableCache> ApptTypesCache = new Dictionary<string, DataTableCache>();
            public static readonly Dictionary<string, DataTableCache> HospLocCache = new Dictionary<string, DataTableCache>();
            public static readonly Dictionary<string, DataTableCache> ProvClinCache = new Dictionary<string, DataTableCache>();
            public static readonly Dictionary<DataTableKey, DataTableCache> SdecResources = new Dictionary<DataTableKey, DataTableCache>();
            public static readonly Dictionary<DataTableKey, DataTableCache> SdecClinSet = new Dictionary<DataTableKey, DataTableCache>();
            public static readonly Dictionary<DataTableKey, DataTableCache> ProhibitedClinicCache = new Dictionary<DataTableKey, DataTableCache>();
            public static readonly Dictionary<DataTableKey, DataTableCache> ClinicStopData = new Dictionary<DataTableKey, DataTableCache>();
            public static readonly Dictionary<string, DataTableCache> PatientSensitiveRecordCache = new Dictionary<string, DataTableCache>();
            public static readonly Dictionary<string, DataTableCache> UserPreferencesCache = new Dictionary<string, DataTableCache>();

            public static void RemoveStaleDataTableCacheRecords(Dictionary<string, DataTableCache> dataCache)
            {
                // Remove any stale records from
                foreach (var item in dataCache.Where(kvp => kvp.Value.IsStale).ToList())
                    dataCache.Remove(item.Key);
            }

            public static void RemoveStaleDataTableCacheRecords(Dictionary<DataTableKey, DataTableCache> dataCache)
            {
                // Remove any stale records from
                foreach (var item in dataCache.Where(kvp => kvp.Value.IsStale).ToList())
                    dataCache.Remove(item.Key);
            }
        }

        public static class AppointmentRequestWaitListTables
        {
            public static DataTable EwlWaitListTemp { get; set; }
            public static DataTable EwlWaitList { get; set; }
            public static DataTable PtCSchWaitList { get; set; }
            public static DataTable ConsultWaitList { get; set; }
            public static DataTable ApptWaitList { get; set; }
            public static ObservableCollection<AppointmentRequest> AllAppointmentRequests { get; set; }
            //public static ObservableCollection<AppointmentRequest> PreviewAppointments { get; set; } 
            public static bool AllAppointmentsLoaded { get; set; }
        }

        public static class RequestKeys
        {
            public static string CurrentSelectedDesiredDate { get; set; }
            public static bool IsPendingApptSelected { get; set; }
        }
        public static class BooleanFlags
        {
            public static bool WaitTimeValueChanged { get; set; }
            public static bool ClearButtonPressed { get; set; }
            private static bool? _refreshWaitList;
            public static bool? RefreshWaitList
            {
                get
                {
                    if (_refreshWaitList == null)
                        return true;
                    return _refreshWaitList;
                }
                set { _refreshWaitList = value; }
            }
        }

        public static class RmGridColumns
        {
            public static string WaitTime                     = "WAIT TIME";
            public static readonly string WaitTimeNull                 = string.Empty;
            public static readonly string WaitTimeAll                  = WaitTime + " All Days";
            public static readonly string WaitTimeGreaterThanEqualTo90 = WaitTime + " >=90 Days";
            public static readonly string WaitTimeBetween30And60       = WaitTime + " 30-60 Days";
            public static readonly string WaitTimeBetween60And90       = WaitTime + " 60-90 Days";
            public static readonly string WaitTimeLessThan30           = WaitTime + " <30 Days";
        }
        public static class RmGridColumnsShort
        {
            public static string WaitTime                     = "WT";
            public static readonly string WaitTimeNull                 = string.Empty;
            public static readonly string WaitTimeAll                  = WaitTime + " All";
            public static readonly string WaitTimeGreaterThanEqualTo90 = WaitTime + " >=90";
            public static readonly string WaitTimeBetween30And60       = WaitTime + " 30-60";
            public static readonly string WaitTimeBetween60And90       = WaitTime + " 60-90";
            public static readonly string WaitTimeLessThan30           = WaitTime + " <30";
        }
        
        public static class RequestManagementKeys
        {
            public static string ServiceSpecialty = "SERVICE/SPECIALITY";
            public static string SpecificClinic   = "SPECIFIC CLINIC";
        }

        public static class WaitListDispositions
        {
            public static string TransferredToEwl         = "TRANSFERRED TO EWL";
            public static string RemovedDeath             = "DEATH";
            public static string RemovedNonVACare         = "REMOVED/NON-VA CARE";
            public static string RemovedScheduledAssigned = "REMOVED/SCHEDULED-ASSIGNED";
            public static string RemovedVAContractCare    = "REMOVED/VA CONTRACT CARE";
            public static string RemovedNoLongerNecessary = "REMOVED/NO LONGER NECESSARY";
            public static string EnteredInError           = "ENTERED IN ERROR";
            public static string MRTCParentClosed         = "MRTC PARENT CLOSED";

            public static bool IsValidMRTCDisposition(string dispositionText)
            {
                var dispUpper = dispositionText.ToUpper();
                return dispUpper == EnteredInError
                       ||
                       dispUpper == RemovedNoLongerNecessary
                       ||
                       dispUpper == RemovedNonVACare
                       ||
                       dispUpper == RemovedDeath;
            }
        }

        public static class PatientPromptRpcs
        {
            public static string SensitiveRecord   = "DG SENSITIVE RECORD ACCESS";
            public static string SensitiveBulletin = "DG SENSITIVE RECORD BULLETIN";
            public static string SimilarRecord     = "DG CHK BS5 XREF ARRAY";
            public static string HasFlag           = "ORPRF HASFLG";
            public static string GetFlag           = "ORPRF GETFLG";
            public static string DiedOn            = "ORWPT DIEDON";
            public static string DiedOnInfo        = "ORWPT ID INFO";
            public static string GetCurrentPatient = "ORWPT TOP";
            public static string SetCurrentPatient = "ORWPT SHARE";
        }

        public static class DeferredRpcCalls
        {
            public static string DeferredRpc          = "XWB DEFERRED RPC";
            public static string DeferredRpcStatus    = "XWB DEFERRED STATUS";
            public static string DeferredRpcGetData   = "XWB DEFERRED GETDATA";
            public static string DeferredRpcClearData = "XWB DEFERRED CLEAR";
        }

        public static class RpcCalls
        {
            public static string GetAppointmentType = "SDECAPP GETYPE";

            public static string SdecCapGet = "SDECCAP GET";
            public static string SdecCapSet = "SDECCAP SET";
            public static string SdecCapCan = "SDECCAP CAN";

            public static string RemoveClnicGroup                    = "SDEC DELRGI";
            public static string AvailabilityEverDefined             = "SDEC NOAVAIL";
            public static string AppointmentSlotsAvailable           = "SDEC APPSLOTS";
            public static string ConflictingApptsForClinic           = "SDEC APBLKOV";
            //public static string ApptBlockAll                      = "SDEC APBLKALL";
            public static string GetProviders                        = "SDEC NEWPERS";
            public static string HospitalLocations                   = "SDEC HOSPLOC";
            public static string ProviderByClinics                   = "SDEC CLINPROV";
            public static string ClinicByProvider                    = "SDEC PROVCLIN";
            public static string AppointmentTypes                    = "SDEC APPTYPES";
            public static string AppAdd                              = "SDEC APPADD";
            public static string WlOpen                              = "SDEC WLOPEN";
            public static string ArOpen                              = "SDEC AROPEN";
            public static string ServerQuery                         = "SDECRMG RMG";
            public static string UpdateDesiredDates                  = "SDEC ARMRTSET";
            public static string CheckAppointmentCountForMrtcRequest = "SDEC ARMRTGET";
            public static string GetResourceUsers                    = "SDEC RESUSER";
            // public static string DisabledClinics                   = "SDEC HIDE";
            // public static string NonDisplayPatientRequests         = "SDEC WLHIDE";

            public static string UnLockAppointmentRequest            = "SDECLK UNLOCK";
            public static string LockAppointmentRequest              = "SDECLK LOCK";

            public static string UpdatePrivilegedUsers               = "SDECLOC UPDPRIV";
            public static string ProhibitedUsers                     = "SDECLOC PRIVLOC";

            public static string InitialWaitListPullRpc              = "SDECIDX GETREC";
            public static string InitialWaitListPullTotalCount       = "SDECIDX RECCNT";

            public static string SdecResource                      = "SDEC RESOURCE";
            public static string ClinSet                           = "SDEC CLINSET";
            public static string GetRaces                          = "SDEC RACEGET";
            public static string GetStates                         = "ROR LIST STATES";
            public static string GetCountries                      = "SDEC CGET";
            public static string CollectionMethod                  = "SDEC ETHCMGET";
            public static string GetPatientRegA                    = "SDEC GETREGA";
            public static string GetEthnicities                    = "SDEC ETHGET";
            public static string PatientLookUpRs                   = "SDEC PTLOOKRS";
            public static string AssociatedClinicsForSvcSpecialty  = "SDEC PCSGET";
            public static string PatientSet                        = "SDEC PTSET";
            public static string PtCSchProviders                   = "SDEC RECPRGET";
            public static string PtCSchSet                         = "SDEC RECSET";
            public static string PtCSchApptTypes                   = "SDEC RECAPGET";
            public static string GetFutureAppointments             = "SDEC FAPPTGET";
            public static string AppointmentRequestSet             = "SDEC ARSET";
            public static string WaitListSet                       = "SDEC WLSET";
            public static string WaitListGet                       = "SDEC WLGET";
            public static string GetConsultAppointmentRequests     = "SDEC REQGET";
            public static string GetPtCSchAppointments             = "SDEC RECGET";
            public static string GetAppointmentRequestFileRequests = "SDEC ARGET";
            public static string WaitListTable                     = "WaitList";
            public static string AuditReportRpc                    = "SDEC SUMMGET";
            public static string AuditReportCancelRpc              = "SDEC SUMMAGET";
            public static string ClinicStop                        = "SDEC PCSTGET";
            public static string ServiceStop                       = "SDEC PCST2GET";
            public static string ClinicReportRpc                   = "SDEC REP1GET";
            public static string AppSDGet                          = "SDEC APPSDGET";
            public static string ClinicListByStopCode              = "SDEC01 CLINICS";

            public static string GetPatientDisabilities            = "SDECDIS DISABIL";

            public static string GetRequestId                      = "SDECAR ARAPPT";
            public static string SetMRTCChildLinks                 = "SDECAR ARMULT";
            public static string MrtcNumApptsBooked                = "SDECAR ARMRTC";

            public static string MartialStatusList                 = "SDECDEM MARITAL";
            public static string ReligionList                      = "SDECDEM RELIGION";
            public static string GetLinkedCityState                = "SDECDEM ZIPLINK";

            public static string UserPreferencesSet                = "SDECRMGP PUTRMGUP";
            public static string UserPreferencesGet                = "SDECRMGP GETRMGUP";

            public static string ConsultUrgency                    = "SDECRMG2 URGENCY";

            public static string PrinterGetFont                    = "SDECU4 GETFONT";
            public static string PrinterSetFont                    = "SDECU4 SETFONT";
            public static string CCOWGetToken                      = "XUS GET CCOW TOKEN";
            public static string CCOWVaultParam                    = "XUS CCOW VAULT PARAM";

            public static class SpecialNeedsRpcs
            {
                public static string SpecialNeedsPreferencesGet      = "SDEC PREFGET";
                public static string SpecialNeedsPreferencesGetValid = "SDEC PREFGETV";
                public static string SpecialNeedsPreferencesSet      = "SDEC PREFSET";
            }
            public static class RpcValues
            {
                //SDEC RECGET-> Eligibility.................................................................
                public static string ServiceConnectedLessThan50Percent  = "SC LESS THAN 50%";
                public static string ServiceConnected50PercentOrGreater = "SERVICE CONNECTED 50% to 100%";
            }
        }

        public static class Methods
        {
            public static DateTime ConvertFileManDateToDateTime(string fileManFormat)
            {
                var centuryFlag = Convert.ToInt32(fileManFormat.Substring(0, 1));
                var century = (17 + centuryFlag).ToString();
                var tmpDate = fileManFormat.Substring(3, 2) + "/" + fileManFormat.Substring(5, 2) + "/" + century + fileManFormat.Substring(1, 2);

                var desiredDate = Convert.ToDateTime(tmpDate);
                return desiredDate;
            }

            public static DateTime ConvertFileManExternalTimeFormatToDateTime(string externalDateTimeFormat)
            {
                var working = externalDateTimeFormat;

                if (working.Contains(","))
                    if (!working.Contains(", "))
                        working = working.Replace(",", ", ");

                var dateVsTime = working.Split('@');
                var dat = dateVsTime[0].Split(' ');
                var sMonth = "";
                switch (dat[0])
                {
                    case "JAN":
                        sMonth += "1";
                        break;
                    case "FEB":
                        sMonth += "2";
                        break;
                    case "MAR":
                        sMonth = "3";
                        break;
                    case "APR":
                        sMonth = "4";
                        break;
                    case "MAY":
                        sMonth = "5";
                        break;
                    case "JUN":
                        sMonth = "6";
                        break;
                    case "JUL":
                        sMonth = "7";
                        break;
                    case "AUG":
                        sMonth = "8";
                        break;
                    case "SEP":
                        sMonth = "9";
                        break;
                    case "OCT":
                        sMonth = "10";
                        break;
                    case "NOV":
                        sMonth = "11";
                        break;
                    case "DEC":
                        sMonth = "12";
                        break;
                    default:
                        return DateTime.MinValue;
                }

                var sDay = dat[1].Replace(",", "");

                var sTimeToReturn = dat[2] + "-" + sMonth + "-" + sDay + " " + dateVsTime[1];

                var timeToReturn = DateTime.ParseExact(sTimeToReturn, "yyyy-M-d HH:mm", CultureInfo.InvariantCulture);
                return timeToReturn;
            }

            public static bool IsApptOrVet(string requestType)
            {
                return requestType == AppointmentRequestTypes.Appt
                       ||
                       requestType == AppointmentRequestTypes.Veteran
                       ||
                       requestType == AppointmentRequestTypes.WelcomeToVa
                       ||
                       requestType == AppointmentRequestTypes.ReturnToClinic;
            }

            public static string ISO8601DateFormat = "yyyy-MM-ddTHH:mm:ssK";

            private static readonly string[] DateFormats =
            {
                ISO8601DateFormat,
                "MMM dd, yyyy@HH:mm:ss",
                "MMM dd,yyyy@HH:mm:ss",
                "MMM dd, yyyy@HH:mm",
                "MMM dd,yyyy@HH:mm",
                "MMM dd, yyyy",
                "MMM dd,yyyy",
                "dd-MMM-yyyy",
                "dd-MMM-yy"
            };

            public static bool TryParseDateTime(string strDate, out DateTime dt)
            {
                if (strDate == null)
                    throw new ArgumentNullException("strDate");

                var culture = new CultureInfo("en-us");
                var dtStyles = DateTimeStyles.AssumeLocal;

                if (DateTime.TryParse(strDate, culture, dtStyles, out dt))
                    return true;

                try
                {
                    dt = DateTime.ParseExact(strDate, DateFormats, culture, dtStyles);
                    return true;
                }
                catch
                {
                    return false;
                }
            }

            public static bool IsDate(object obj)
            {
                if (obj == null)
                    return false;
                var strDate = obj.ToString();
                try
                {
                    var dt = DateTime.Parse(strDate);
                    if (dt != DateTime.MinValue && dt != DateTime.MaxValue)
                        return true;
                    return false;
                }
                catch
                {
                    return false;
                }
            }

            public static bool IsNumeric(string s)
            {
                float output;
                return float.TryParse(s, out output);
            }

            private static readonly Key[] SpecialKeys =
            {
                Key.Back,
                Key.Decimal,
                Key.Divide,
                Key.LeftShift,
                Key.RightShift,
                Key.Multiply,
                Key.OemBackslash,
                Key.OemCloseBrackets,
                Key.OemComma,
                Key.OemMinus,
                Key.OemOpenBrackets,
                Key.OemPeriod,
                Key.OemPipe,
                Key.OemPlus,
                Key.OemQuestion,
                Key.OemQuotes,
                Key.OemSemicolon,
                Key.OemTilde,
                Key.Space,
                Key.Subtract
            };

            public static bool ComboBoxStartDataLookupKey(Key key)
            {
                return
                    (key >= Key.A && key <= Key.Z)
                    ||
                    (key >= Key.D0 && key <= Key.D9)
                    ||
                    (key >= Key.NumPad0 && key <= Key.NumPad9)
                    ||
                    SpecialKeys.Contains(key);
            }

            public static DateTime DateTime_Ceiling(DateTime date, TimeSpan span)
            {
                var ticks = (date.Ticks + span.Ticks - 1)/span.Ticks;
                return new DateTime(ticks*span.Ticks);
            }

            public static DateTime DateTime_Floor(DateTime date, TimeSpan span)
            {
                var ticks = date.Ticks/span.Ticks;
                return new DateTime(ticks*span.Ticks);
            }

            public static DateTime DateTime_Round(DateTime date, TimeSpan span, bool upOnMidpoint = true)
            {
                var ticks = (date.Ticks + span.Ticks/2 + (upOnMidpoint ? 1 : -1))/span.Ticks;
                return new DateTime(ticks*span.Ticks);
            }

            public static bool TimesOverlap(DateTime dStart1, DateTime dEnd1, DateTime dStart2, DateTime dEnd2)
            {
                var bRet = (dStart2 > dStart1 && dStart2 < dEnd1)
                           || (dEnd2 > dStart1 && dEnd2 < dEnd1)
                           || (dStart1 > dStart2 && dStart1 < dEnd2)
                           || (dEnd1 > dStart2 && dEnd1 < dEnd2)
                           || (dEnd2 == dEnd1)
                           || (dStart2 == dStart1);
                return bRet;
            }

            public static string DayOfWeekCode(DayOfWeek source)
            {
                switch (source)
                {
                    case DayOfWeek.Monday:
                        return "M";
                    case DayOfWeek.Tuesday:
                        return "T";
                    case DayOfWeek.Wednesday:
                        return "W";
                    case DayOfWeek.Thursday:
                        return "H";
                    case DayOfWeek.Friday:
                        return "F";
                    case DayOfWeek.Saturday:
                        return "S";
                    case DayOfWeek.Sunday:
                        return "U";
                    default:
                        return string.Empty;
                }
            }

            public static bool StrToBool(string source)
            {
                bool sout;

                if (bool.TryParse(source, out sout))
                    return sout;

                return source == "1"
                       ||
                       source.ToUpper() == "Y"
                       ||
                       source.ToUpper() == "YES"
                       ||
                       source.ToUpper() == "T"
                       ||
                       source.ToUpper() == "TRUE";
            }

            public const string VALID_PHONE_INPUT = "0123456789 +-xX()";
            public const string VALID_MOBILE_PHONE_INPUT = "1234567890 -()";

            public static string StandardPhoneFormat(string source, bool isMobilePhone = false)
            {
                // If no Phone Number return emty string
                if (string.IsNullOrEmpty(source))
                    return string.Empty;

                string phone = source;
                string ext = string.Empty;

                if (!isMobilePhone)
                {
                    // Look for extension information
                    List<string> extList = new List<string>
                    {
                        " extension",
                        " ext",
                        " ex",
                        " e",
                        " x",
                        "extension",
                        "ext",
                        "ex",
                        "e",
                        "x"
                    };

                    foreach (string item in extList)
                    {
                        if (source.Contains(item))
                        {
                            string[] p1 = source.Replace(item, "^").Split('^');
                            phone = p1[0];
                            ext = p1[1];
                            break;
                        }
                        if (source.Contains(item.ToUpper()))
                        {
                            string[] p1 = source.Replace(item.ToUpper(), "^").Split('^');
                            phone = p1[0];
                            ext = p1[1];
                            break;
                        }
                    }
                }

                // strip all non-numeric characters
                string wPhone = new string(phone.Trim().Where(x => char.IsDigit(x)).ToArray());
                string wExt = new string(ext.Trim().Where(x => char.IsDigit(x)).ToArray());

                // if both wPhone and wExt are empty return empty
                if (string.IsNullOrEmpty(wPhone) && string.IsNullOrEmpty(wExt))
                    return string.Empty;

                if (!string.IsNullOrEmpty(wExt))
                    wExt = " X" + wExt;

                // length > 13 will be assumed to be 13 digit international number plus extension
                if (wPhone.Length > 13)
                {
                    if (isMobilePhone)
                        return "+" + source;
                    else
                    {
                        string number = wPhone.Substring(0, 13);
                        string ex = wPhone.Replace(number, "");
                        return new StringBuilder(16 + ex.Length)
                            .Append("+")
                            .Append(number)
                            .Append(" x" + ex)
                            .ToString();
                    }
                }

                // length is greater than 10 (Includes for Country Codes)
                if (wPhone.Length > 10)
                    return new StringBuilder(wPhone.Length + 1 + wExt.Length)
                        .Append("+")
                        .Append(wPhone)
                        .Append(wExt)
                        .ToString();

                //if length is 10 (Includes area code)
                if (wPhone.Length == 10)
                    return new StringBuilder(14 + wExt.Length)
                        .Append("(")
                        .Append(wPhone.Substring(0, 3))
                        .Append(") ")
                        .Append(wPhone.Substring(3, 3))
                        .Append("-")
                        .Append(wPhone.Substring(6))
                        .Append(wExt)
                        .ToString();

                //if length is 7 (No area code)
                if (wPhone.Length == 7)
                    return new StringBuilder(8 + wExt.Length)
                        .Append(wPhone.Substring(0, 3))
                        .Append("-")
                        .Append(wPhone.Substring(3))
                        .Append(wExt)
                        .ToString();

                //if length is 4 (No area code, no Exchange number)
                if (wPhone.Length <= 4)
                    return new StringBuilder(wPhone.Length + wExt.Length)
                        .Append(wPhone)
                        .Append(wExt)
                        .ToString();

                // if no phone, but has ext then return the extension
                if (string.IsNullOrEmpty(wPhone) && !string.IsNullOrEmpty(wExt))
                    return wExt;

                // No format found, return the original string
                return source;
            }

            public static IEnumerable<string> SplitByLength(string s, int length)
            {
                for (int i = 0; i < s.Length; i += length)
                {
                    if (i + length <= s.Length)
                    {
                        yield return s.Substring(i, length);
                    }
                    else
                    {
                        yield return s.Substring(i);
                    }
                }
            }

        }

        public static double distance(double lat1, double lon1, double lat2, double lon2, char unit)
        {
            var theta = lon1 - lon2;
            var dist = Math.Sin(deg2rad(lat1))*Math.Sin(deg2rad(lat2)) +
                          Math.Cos(deg2rad(lat1))*Math.Cos(deg2rad(lat2))*Math.Cos(deg2rad(theta));
            dist = Math.Acos(dist);
            dist = rad2deg(dist);
            dist = dist*60*1.1515;
            if (unit == 'K')
                dist = dist*1.609344;
            else if (unit == 'N')
                dist = dist*0.8684;
            return dist;
        }

        private static double deg2rad(double deg) 
        {
          return deg * Math.PI / 180.0;
        }

        private static double rad2deg(double rad) 
        {
            return rad / Math.PI * 180.0;
        }

        private static void SetRenderingMode(HwndSource source)
        {
            if (source != null)
            {
                var hwndTarget = source.CompositionTarget;
                hwndTarget.RenderMode = RenderMode.SoftwareOnly;
            }
        }

        public static void SetRenderingMode(UserControl control)
        {
            SetRenderingMode(PresentationSource.FromVisual(control) as HwndSource);
        }

        public static void SetRenderingMode(Window window)
        {
            SetRenderingMode(PresentationSource.FromVisual(window) as HwndSource);
        }

        public static Window GetWindowOwner(Window window)
        {
            return window == null || !window.IsVisible ? MainWindow : window;
        }

        public static Rect CurrentScreenDimensions()
        {
            var screen = 
                    System.Windows.Forms.Screen.FromHandle(
                        new WindowInteropHelper(MainWindow).Handle
                    );

            var screenRect = screen.WorkingArea;
            return new Rect(screenRect.Left, screenRect.Top, screenRect.Right - screenRect.Left + 1, screenRect.Bottom - screenRect.Top + 1);
        }

        public static void AlertUser(object owner, string message, string caption = "")
        {
            ShowMessage( owner, message, caption, MessageBoxButton.OK, MessageBoxImage.Information );
        }

        public static void AlertUserError(object owner, Exception ex, string caption = "")
        {
            var message = new StringBuilder();
            var tCount = 0;

            while (ex != null)
            {
                message.Append((tCount == 0 ? string.Empty : new string('\t', tCount) + "Inner Exception: ") + ex.Message);
                ex = ex.InnerException;
            }
            ShowMessage(owner, message.ToString(), caption, MessageBoxButton.OK, MessageBoxImage.Error);
        }

        public static bool ConfirmUser(DependencyObject owner, string message, string caption = "", bool useYesNo = false, MessageBoxImage image = MessageBoxImage.Question)
        {
            DependencyObject win = owner;

            if (win == null)
                win = MainWindow;

            if (useYesNo)
                return MessageBox.Show(
                           GetWindowOwner(Window.GetWindow(win)),
                           message,
                           caption,
                           MessageBoxButton.YesNo,
                           image,
                           MessageBoxResult.Yes
                       ) == MessageBoxResult.Yes;
            return MessageBox.Show(
                       GetWindowOwner(Window.GetWindow(win)),
                       message,
                       caption,
                       MessageBoxButton.OKCancel,
                       image,
                       MessageBoxResult.OK
                   ) == MessageBoxResult.OK;
        }

        public static void WarnUser(object owner, string message, string caption = "")
        {
            ShowMessage(owner, message, caption, MessageBoxButton.OK, MessageBoxImage.Warning );
        }

        public static bool PromptUser(string title, string question, ref string answer, int height = 0, int width = 0, int maxLength = 250, string name = "")
        {
            var dlg = new Controls.InputBox(question, answer, maxLength);
            CLaunchWindow.LaunchWindow(dlg, title, height == 0 ? 150 : height, width == 0 ? 400 : width, name);
            var result = dlg.DialogResult;

            if (result)
                answer = dlg.Answer;

            return result;
        }

        private static void ShowMessage(object owner, string message, string caption, MessageBoxButton button, MessageBoxImage image)
        {
            var newOwner = MainWindow;

            if ( owner != null && owner is DependencyObject )
            {
                var depObject = (DependencyObject)owner;
                newOwner = depObject is Window ? (Window)depObject : GetWindowOwner( Window.GetWindow( depObject ) );
            }

            if (string.IsNullOrEmpty(caption))
                caption = "VSE Scheduling Error";

            MessageBox.Show(newOwner, message, caption, button, image);
//            MainWindow.Dispatcher.BeginInvoke(new Action(() => MessageBox.Show(newOwner, message, caption, button, image)));
        }

        public enum OverbookingStatus
        {
            NotRequired,
            Cannot,
            Required
        }

        public static void BlockingMethod(double seconds)
        {
            #if DEBUG
            DateTime then = DateTime.Now;

            do
            {
                System.Threading.Thread.Sleep((int)TimeSpan.FromSeconds(seconds).TotalMilliseconds);
            } while (DateTime.Now.CompareTo(then) <= 0);
            #endif
        }

        public static IList<NameValue> RequestedByOptions
        {
            get
            {
                return new List<NameValue>()
                {
                    new NameValue("PATIENT", "2"),
                    new NameValue("PROVIDER", "1")
                };
            }
        }
    }

    public class DataTableKey
    {
        public string IEN { get; private set; }
        public string Name { get; private set; }

        public DataTableKey(string ien, string name)
        {
            IEN = ien;
            Name = name;
        }
    }

    public class DataTableCache
    {
        private readonly int _expiresInMinutes;

        private DateTime _readTime { get; }

        public DataTableCache(DataTable table, int expiresInMinutes = 15)
        {
            Table = table;
            _readTime = DateTime.Now;
            _expiresInMinutes = expiresInMinutes;
        }

        public DataTableCache(string[][] array, int expiresInMinutes = 15)
        {
            Array = array;
            _readTime = DateTime.Now;
            _expiresInMinutes = expiresInMinutes;
        }

        public DataTableCache(string singleValue, int expiresInMinutes = 15)
        {
            SingleValue = singleValue;
            _readTime = DateTime.Now;
            _expiresInMinutes = expiresInMinutes;
        }

        public DataTable Table { get; }

        public string[][] Array { get; private set; }

        public string SingleValue { get; }

        public bool IsStale { get { return DateTime.Now > _readTime.AddMinutes(_expiresInMinutes); } }

    }
}
