﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace ClinSchd.Infrastructure.Models
{
	public class AutoRebookData : INotifyPropertyChanged
	{
	    private bool _isAccessTypeChecked;

	    public bool IsAccessTypeChecked
	    {
	        get { return _isAccessTypeChecked; }
	        set
	        {
	            _isAccessTypeChecked = value;
                OnPropertyChanged( "AutoRebook" );

            }
        }

	    public int AccessTypeID { get; set; }
		public int MinimumDays { get; set; }
		public int MaximumDays { get; set; }
		public SchdAppointment RebookAppointment { get; set; }

		public AutoRebookData ()
		{
			this.RebookAppointment = new SchdAppointment ();
		}

	    public event PropertyChangedEventHandler PropertyChanged;

	    protected virtual void OnPropertyChanged( string propertyName )
	    {
	        PropertyChanged?.Invoke( this, new PropertyChangedEventArgs( propertyName ) );
	    }
	}
}
