﻿using System;
using System.ComponentModel;

namespace ClinSchd.Infrastructure.Models
{
    public class CancelAppointment : INotifyPropertyChanged
    {
        public string ApptID { get; set; }

        private bool _cancelledByClinic = true;
        public bool CancelledByClinic
        {
            get
            {
                return _cancelledByClinic;
            }
            set
            {
                if (_cancelledByClinic != value)
                {
                    _cancelledByClinic = value;
                    OnPropertyChanged("CancelledByClinic");
                    //if (_cancelledByClinic)
                    //{
                    //    PatientDesiredDate = DateTime.Now;
                    //}
                }
            }
        }

        public string ReasonIEN
        {
            get { return _reasonIEN; }
            set
            {
                _reasonIEN = value;
                OnPropertyChanged( "ReasonIEN" );
            }
        }

        public string Notes { get; set; }
        public string PatientID { get; set; }

        private DateTime _patientDesiredDate;
        public DateTime PatientDesiredDate
        {
            get
            {
                if (_patientDesiredDate == DateTime.MinValue)
                {
                    _patientDesiredDate = DateTime.Now;
                }
                return _patientDesiredDate;
            }
            set
            {
                if (_patientDesiredDate != value)
                {
                    _patientDesiredDate = value;
                    OnPropertyChanged("PatientDesiredDate");
                }
            }
        }
        private DateTime _originalDesiredDate;
        private string _reasonIEN;

        public DateTime OriginalDesiredDate
        {
            get
            {
                if (_originalDesiredDate == DateTime.MinValue)
                {
                    _originalDesiredDate = DateTime.Now;
                }
                return _originalDesiredDate;
            }
            set
            {
                if (_originalDesiredDate != value)
                {
                    _originalDesiredDate = value;
                    OnPropertyChanged("OriginalDesiredDate");
                }
            }
        }
        public void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
