﻿using System.ComponentModel;

namespace ClinSchd.Infrastructure.Models
{
    public class CheckInPatient : INotifyPropertyChanged
    {
        private string _providerIEN;

        public string ApptID { get; set; }
        public string CheckInDateTime { get; set; }
        public string ClinicStopIEN { get; set; }

        public string ProviderIEN
        {
            get { return _providerIEN; }
            set
            {
                _providerIEN = value;
                OnPropertyChanged( "ProviderIEN" );
            }
        }
        public string PatientIEN { get; set; }

        public bool PrintRouteSlip { get; set; }
        public string HealthSummaryLetterIEN { get; set; }
        public bool PrintWellnessHandout { get; set; }
        public string PCCClinicIEN { get; set; }
        public string PCCFormIEN { get; set; }
        public bool PCCOutGuide { get; set; }
        public bool MakeChartRequest { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged( string propertyName )
        {
            PropertyChanged?.Invoke( this, new PropertyChangedEventArgs( propertyName ) );
        }
    }
}
