﻿using System.Collections.Generic;

// Structure for holding the Filter info for each column

namespace ClinSchd.Infrastructure.Models
{
    public class FilterInfo
    {
        public bool IsFiltered { get; set; }

        public string ColumnName { get; set; }

        public int Column { get; set; }

        public List<string> Filters { get; set; } = new List<string>();

        public int SortOrder { get; set; }

        public bool IsServiceList { get; set; }

        public FilterInfo( int column, string columnName, bool isFiltered, string filter, bool isServiceList, int sortOrder )
        {
            ColumnName = columnName;
            Column = column;

            IsFiltered = isFiltered;

            var items = filter.Split( ',' );
            foreach ( var item in items )
                Filters.Add( item.Trim() );

            IsServiceList = isServiceList;
            SortOrder = sortOrder;
        }
    }
}
