﻿using System;
using System.ComponentModel;

namespace ClinSchd.Infrastructure.Models
{
    public class FindAppointmentResult : INotifyPropertyChanged
    {
        public string StartTime { get; set; }
        public string EndTime { get; set; }
        public string ResourceName { get; set; }

        public string Slots { get; set; }
        public int AvailabilityCount { get; set; }
        public string AccessType { get; set; }
        private bool _book;
        public bool Book {
            get { return _book; }
            set
            {
                if (Equals(value, _book)) return;
                _book = value;
                OnPropertyChanged("Book");
            }
        }

        public DateTime? DesiredAppointmentDate { get; set; }
        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
