﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace ClinSchd.Infrastructure.Models
{
    public class FuturePatientAppointment : INotifyPropertyChanged
    {
        public string Dfn { get; set; }
        private string _appointmentDate;

        public string AppointmentID { get; set; }

        public string AppointmentDate
        {
            get { return _appointmentDate; }
            set
            {
                if (Equals(value, _appointmentDate)) return;
                _appointmentDate = value;
                OnPropertyChanged("AppointmentDate");
            }
        }
        public string Clinic { get; set; }
        public string ClinicIen { get; set; }
        private string _status;
        public string Status
        {
            get
            {
                if (!string.IsNullOrEmpty(AncillaryText))
                    return _status + AncillaryText;
                return _status;
            }
            set { _status = value; }
        }
        public string AncillaryText { get; set; }
        public bool IsAncillary
        { 
            get { return !string.IsNullOrEmpty(AncillaryText); }
        }

        public string ConsultID { get; set; }

        public string StatusText { get { return ((String.IsNullOrEmpty(ConsultID) ? String.Empty : "CONS-") + Status); } }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }

		public DateTime AppointmentDateTime { get; set; }

		public bool IsCancelled { get; set; }
	}
}
