using System.ComponentModel;

namespace ClinSchd.Infrastructure.Models
{
    public class NameValue : INotifyPropertyChanged
    {
        public NameValue ()
        {
        }

        public NameValue (string name, string value) : this()
        {
            Name = name;
            Value = value;
        }

        public NameValue(string name, string value, string lastSub) : this(name, value)
        {
            LastSub = lastSub;
        }

        private string _name;
        public string Name 
        {
            get { return _name; }
            set
            {
                if (Equals(value, _name)) return;
                _name = value;
                OnPropertyChanged("Name");
            }
        }
        public string Value { get; set; }

        public string LastSub { get; set; }
        public string AlternateValue { get; set; }
        public string AlternateName { get; set; }
        public bool MoreRecords { get; set; } = false;

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
