﻿using System.ComponentModel;

namespace ClinSchd.Infrastructure.Models
{
	public class PassthroughAsyncModel : AsyncValidatableModel
	{
		public void InvokeAsync (WorkMethod methodToInvoke, WorkCompletedMethod callbackMethod)
		{
			DoWorkAsync ((s,args) => {methodToInvoke.Invoke(s,args);}, callbackMethod);
		}

		public new delegate void WorkMethod (object s, DoWorkEventArgs args);

	}
}
