﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ClinSchd.Infrastructure.Models
{
    public class PatientDisabilityModel
    {
        public string IEN { get; private set; }
        public string Name { get; private set; }
        public string Percentage { get; private set; }
        public string PercentageText { get { return (String.IsNullOrEmpty(Percentage) ? String.Empty : String.Format("{0}%", Percentage)); } }
        public bool ServiceConnected { get; private set; }
        public string ServiceConnectedText { get { return (ServiceConnected ? "YES" : "NO"); } }
        public NameValue Extremety { get; private set; }
        public string OriginalDate { get; private set; }
        public string CurrentDate { get; private set; }

        public PatientDisabilityModel(string source)
        {
            if (String.IsNullOrEmpty(source))
                return;

            string[] separator = { ";;" };
            string[] parts = source.Split(separator, 7, System.StringSplitOptions.None);
            IEN = parts[0];
            Name = parts[1];
            Percentage = parts[2];
            ServiceConnected = (parts[3] == "1");
            Extremety = PatientDisabilitiesModel.ExtremetyList.FirstOrDefault(e => (e.Value == parts[4]));
            OriginalDate = parts[5];
            CurrentDate = parts[6];
        }
    }
}
