﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ClinSchd.Infrastructure.Models
{
    public class PatientGAF
    {
        #region constructor

        public PatientGAF()
        {
            Text = String.Empty;
            Score = String.Empty;
            Date = String.Empty;
            DiagnosisByIEN = String.Empty;
            DiagnosisByName = String.Empty;
        }

        public PatientGAF(string source) : this()
        {
            All = source;
        }

        #endregion constructor

        #region public members

        public string All
        {
            get
            {
                List<string> results = new List<string>()
                {
                    Text,
                    Score,
                    Date,
                    DiagnosisByIEN,
                    DiagnosisByName
                };
                string result = String.Join("|", results.ToArray());

                if (result == "||||")
                    return String.Empty;
                else
                    return result;
            }
            set
            {
                var pcs = value.Split('|');

                if (pcs.Length > 2)
                {
                    Text = pcs[0];
                    Score = pcs[1];
                    Date = pcs[2];
                }

                if (pcs.Length == 5)
                {
                    DiagnosisByIEN = pcs[3];
                    DiagnosisByName = pcs[4];
                }
            }
        }

        public string Text { get; set; }

        public string Score { get; set; }

        public string Date { get; set; }

        public string DiagnosisByIEN { get; set; }

        public string DiagnosisByName { get; set; }

        #endregion public members
    }
}