﻿using System;

using ClinSchd.Infrastructure.Interfaces;

namespace ClinSchd.Infrastructure.Models
{
    public class PatientNextOfKin : MonitoredValuesBaseClass
    {
        #region private fields

        private IDataAccessService _dataAccessService = null;
        private string _patientIEN;

        #endregion private fields

        #region constructor

        public PatientNextOfKin(IDataAccessService dataAccessService, string patientIEN)
        {
            _dataAccessService = dataAccessService;
            ContactInfo = new ContactInfo(dataAccessService, patientIEN);
            PatientIEN = patientIEN;
        }

        #endregion constructor

        #region public members

        public string IEN { get; set; }

        public string PatientIEN
        {
            get { return _patientIEN; }
            set
            {
                _patientIEN = value;
                ContactInfo.PatientIEN = value;
            }
        }

        public string Name
        {
            get { return GetMonitoredValue("Name"); }
            set { SetMonitoredValue("Name", value); }
        }

        public string Relationship
        {
            get { return GetMonitoredValue("Relationship"); }
            set { SetMonitoredValue("Relationship", value); }
        }

        public ContactInfo ContactInfo { get; set; }

        #endregion public members
    }
}
