﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ClinSchd.Infrastructure.Models
{
    public class PatientSensitiveRecord
    {
        #region constructors

        public PatientSensitiveRecord()
        {
            Code = -1;
            Message = String.Empty;
        }

        public PatientSensitiveRecord(string source)
        {
            Initialize(source);
        }

        public PatientSensitiveRecord(string code, string message)
        {
            if (!String.IsNullOrEmpty(code))
                Code = Convert.ToInt32(code);

            Message = Message;
        }

        #endregion constructors

        #region public members

        public void Initialize(string source)
        {
            if (source.Contains("|"))
            {
                string[] parts = source.Split('|');

                if (!String.IsNullOrEmpty(parts[0]))
                    Code = Convert.ToInt32(parts[0]);

                Message = parts[1];
            }
            else
                Code = Convert.ToInt32(source);
        }

        public int Code { get; set; }

        public string Message { get; set; }

        public bool IsSensitiveRecord { get { return ((Code == 1) || (Code == 2)); } }
        
        #endregion public members
    }
}
