﻿using System.ComponentModel;

namespace ClinSchd.Infrastructure.Models
{
    public class ProhibitedClinic : INotifyPropertyChanged
    {
        private string _name;
        public string Name 
        {
            get { return _name; }
            set
            {
                if (Equals(value, _name)) return;
                _name = value;
                OnPropertyChanged("Name");
            }
        }
        
        public string Ien { get; set; }
        public string HospitalLocationId { get; set; }

        public string ResourceType
        {
            get { return ResourceTypeCode + "|" + ResourceTypeIEN + "|" + ResourceTypeName; }
            set
            {
                ResourceTypeCode = string.Empty;
                ResourceTypeIEN = string.Empty;
                ResourceTypeName = string.Empty;

                if (!string.IsNullOrEmpty(value))
                {
                    string[] resValues = value.Split('|');

                    if (resValues.Length >= 1)
                        ResourceTypeCode = resValues[0];

                    if (resValues.Length >= 2)
                        ResourceTypeIEN = resValues[1];

                    if (resValues.Length >= 3)
                        ResourceTypeName = resValues[2];
                }
            }
        }
        public string ResourceTypeCode { get; set; }
        public string ResourceTypeIEN { get; set; }
        public string ResourceTypeName { get; set; }
        public string LastSub { get; set; }
        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
