using System.Collections.Generic;
using ClinSchd.Infrastructure.Interfaces;

namespace ClinSchd.Infrastructure.Models
{
    public class Provider : AsyncValidatableModel
    {
        public IDataAccessService DataAccessService;
        private string _name;

        public string IEN { get; set; }

        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                NotifyPropertyChanged( "Name" );
            }
        }

        public bool IsDefaultProvider { get; set; }
        public Provider()
        {
            
        }
        public Provider (IDataAccessService dataAccessService)
        {
            DataAccessService = dataAccessService;
        }

        public IList<SchdResource> Resources { get; set; }
        public bool HasResources { get; set; }
        public string LastSub { get; set; }
        /*private bool _hasResources;
        public bool HasResources { 
            get
            {
                if (Resources == null)
                    return false;
                return (Resources.Count > 0);
            } 
            set { _hasResources = value; }
        }*/

/*		public void GetAllProviders (WorkCompletedMethod workCompletedMethod)
        {
            DoWorkAsync ((s, args) => {
                args.Result = dataAccessService.GetProviders ();
            }, workCompletedMethod);
        }
*/

/*        public void GetAllProvidersWithResources(WorkCompletedMethod workCompletedMethod)
        {
            DoWorkAsync((s, args) =>
            {
                IList<Provider> list = dataAccessService.GetProviders();
                IList<Provider> results = new List<Provider>();

                foreach (Provider item in list)
                    if (item.HasResources)
                        results.Add(item);

                args.Result = results; // dataAccessService.GetProviders();
            }, workCompletedMethod);
        }
*/
    }
}
