﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls;

namespace ClinSchd.Infrastructure.Models
{
    public class RMGridExportModel
    {
        private AppointmentRequest _request;

        public RMGridExportModel(AppointmentRequest request)
        {
            _request = request;
        }

        public string REQUEST_TYPE { get { return _request.AppointmentRequestType; } }

        public int? WAIT_TIME { get { return _request.WaitTime; } }

        public string PT_NAME { get { return _request.Patient.Name; } }

        public bool MRTC { get { return _request.MultipleAppointmentsRequired; } }

        public string SSN { get { return _request.Patient.SSNFormatted; } }

        public bool SCVisit { get { return _request.Patient.SCVisitBool; } }

        public string TELEPHONE { get { return _request.Patient.PrimaryContactInfo.Phone; } }

        public string PRIORITY { get { return _request.Patient.PriorityGroup; } }

        public string DESIRED_PtCSch_DATE { get { return _request.DesiredAppointmentDateByType; } }

        public string ENTERED_RR_NO_DATE { get { return _request.OriginatingDateString; } }

        public string REQUESTOR { get { return _request.RequestedByText; } }

        public string REQUESTED_BY { get { return _request.RequestedByProviderMerge; } }

        public string CLINIC_SERVICE { get { return _request.ClinicServiceSpecialtyMerge; } }

        public string COMMENT { get { return _request.RequestManagementCommentTrunc; } }
    }
}
