﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ClinSchd.Infrastructure.Interfaces;
using Telerik.Windows.Controls.ScheduleView;
using Telerik.Windows.Controls;

namespace ClinSchd.Infrastructure.Models
{
	public class SchdAppointmentSource
	{
		public CustomAppointmentCollection Appointments
		{
			get;
			set;
		}

        public SchdAppointmentSource(IList<SchdAppointment> appointmentList, bool isEnableUpdateAppointment)
		{
            this.Appointments = new CustomAppointmentCollection();

            if (appointmentList == null)
                return;

		   foreach (SchdAppointment newAppointment in appointmentList)
		   {
			   CustomAppointment _appt = new CustomAppointment (newAppointment);
                _appt.Resources.Add(new Resource(Keys.AppointmentGroupNames.Appointment, Keys.AppointmentGroupNames.Appointment));
                _appt.IsEnableUpdateAppointment = isEnableUpdateAppointment;
                Appointments.Add (_appt);
		   }
		}

		public SchdAppointmentSource (IList<SchdAvailability> availabilityList, Dictionary<string, Category> categories, bool isEnableUpdateAppointment)
		{
			this.Appointments = new CustomAppointmentCollection ();
            DateTime? currentDate = null;
            List<SchdAvailability> filteredAvailabilityList = new List<SchdAvailability>();
            List<SchdAvailability> dailyAvailabilityList = new List<SchdAvailability>();

            foreach (SchdAvailability newAppointment in availabilityList)
            {
                DateTime apptStart = Convert.ToDateTime(newAppointment.StartTime).Date;

                if (!currentDate.HasValue)
                    currentDate = apptStart;
                else if (currentDate.Value.CompareTo(apptStart) != 0)
                {
                    if (dailyAvailabilityList.Count(a => (a.ACCESSTYPEID != Keys.AccessTypes.Unavailable)) > 0)
                        filteredAvailabilityList.AddRange(dailyAvailabilityList);

                    dailyAvailabilityList.Clear();
                    currentDate = apptStart;
                }

                dailyAvailabilityList.Add(newAppointment);
            }

            if (dailyAvailabilityList.Count > 0)
            {
                if (dailyAvailabilityList.Count(a => (a.ACCESSTYPEID != Keys.AccessTypes.Unavailable)) > 0)
                    filteredAvailabilityList.AddRange(dailyAvailabilityList);

                dailyAvailabilityList.Clear();
            }

            foreach (SchdAvailability newAppointment in filteredAvailabilityList)
            {
                CustomAppointment _appt = new CustomAppointment();
				//if (!isEnableUpdateAppointment) {
					_appt.IsEditAccessBlockEnabled = false;
					_appt.IsDeleteAccessBlockEnabled = false;
				//}

                _appt.Subject = $"{newAppointment.ACCESSTYPENAME}:"
                    + $"\n  {newAppointment.SlotCount} Appointment(s)/Slot"
                    + $"\n  {newAppointment.Duration} minute Slot(s).";
                _appt.Body = newAppointment.Note;
                _appt.Start = Convert.ToDateTime(newAppointment.StartTime);
                _appt.End = Convert.ToDateTime(newAppointment.EndTime);
                _appt.UniqueId = newAppointment.APPOINTMENTID;
                _appt.Category = categories[newAppointment.ACCESSTYPEID];
                _appt.Resources.Add(new Resource(Keys.AppointmentGroupNames.Appointment, Keys.AppointmentGroupNames.Appointment));

                this.Appointments.Add (_appt);
			}
		}

	}
}
