﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ClinSchd.Infrastructure.Models
{
    public class SlotsAvailable
    {
        public string ClinicIen { get; set; }
        public string ResourceId { get; set; }
        public string Name { get; set; }
        public IList<CSlot> Slots { get; set; }
        //public int SlotCount { get; set; }
        public DateTime? StartTime
        {
            get
            {
                if (Slots == null)
                    return null;

                if (Slots.Count == 0)
                    return null;

                return Slots[0].StartTime;
            }
        }
        public DateTime? EndTime
        {
            get
            {
                if (Slots == null)
                    return null;

                if (Slots.Count == 0)
                    return null;

                return Slots[Slots.Count - 1].EndTime;
            }
        }
        public Int32? Duration
        {
            get
            {
                if (Slots == null)
                    return null;

                if (Slots.Count == 0)
                    return null;

                return (Int32?)(EndTime.Value - StartTime.Value).TotalMinutes;
            }
        }
    }
}
