﻿// The complete list of all filter criteria for the RM Grid

namespace ClinSchd.Infrastructure.Models
{
    public class UserPreferences
    {
        public bool AreDefined { get; set; }
        public FilterInfo RequestType { get; set; }

        public FilterInfo WaitTime { get; set; }

        public FilterInfo PatientName { get; set; }

        public FilterInfo SSN { get; set; }

        public FilterInfo SCVisit { get; set; }

        public FilterInfo Telephone { get; set; }

        public FilterInfo PriorityGroup { get; set; }

        public FilterInfo MRTC { get; set; }

        public FilterInfo PreferredDate { get; set; }

        public FilterInfo EnteredDate { get; set; }

        public FilterInfo Requestor { get; set; }

        public FilterInfo RequestedBy { get; set; }

        public FilterInfo ClinicService { get; set; }

        public FilterInfo Comment { get; set; }

        public UserPreferences()
        {
            AreDefined = false;
        }
        public UserPreferences(
            FilterInfo requestType,
            FilterInfo waitTime,
            FilterInfo patientName,
            FilterInfo ssn,
            FilterInfo mrtc,
            FilterInfo scVisit,
            FilterInfo telephone,
            FilterInfo priorityGroup,
            FilterInfo preferredDate,
            FilterInfo enteredDate,
            FilterInfo requestor,
            FilterInfo requestedBy,
            FilterInfo clinicService,
            FilterInfo comment )
        {
            RequestType = requestType;
            WaitTime = waitTime;
            PatientName = patientName;
            SSN = ssn;
            MRTC = mrtc;
            SCVisit = scVisit;
            Telephone = telephone;
            PriorityGroup = priorityGroup;
            PreferredDate = preferredDate;
            EnteredDate = enteredDate;
            Requestor = requestor;
            RequestedBy = requestedBy;
            ClinicService = clinicService;
            Comment = comment;
        }
    }
}
