﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;

using MSC.TraceLog.Classes;

namespace ClinSchd.Infrastructure
{
    public sealed class TraceLog
    {
        #region static members

        public static void AttachToSystemMenu(IntPtr handle, bool showModal = false)
        {
            mscTraceLog.AttachToSystemMenu(handle, showModal);
        }

        public static string DumpFileLocation
        {
            get { return mscTraceLog.DumpFileLocation; }
            set { mscTraceLog.DumpFileLocation = value; }
        }

        public static void SaveLogToFile(string fileName)
        {
            mscTraceLog.DumpLogToFile(fileName);
        }

        public static string FormatExceptionMessage(string className, string methodName, Exception exception)
        {
            return mscTraceLog.FormatExceptionMessage(className, methodName, exception);
        }

        public static void LogException(string className, string methodName, Exception exception)
        {
            mscTraceLog.LogException(className, methodName, exception);
        }

        public static void LogInfo(string classText, string typeText, string messageText)
        {
            mscTraceLog.LogInfo(classText, typeText, messageText);
        }

        public static void LogRPCInfo(string rpcName, object parameters, object response, List<TimeSpan?> executionTimesList = null)
        {
            mscTraceLog.LogRPCInfo(rpcName, parameters, response, executionTimesList );
        }

        public static bool UseSoftwareRendering
        {
            get { return mscTraceLog.UseSoftwareRendering; }
            set { mscTraceLog.UseSoftwareRendering = value; }
        }

        public static void ViewLog(IntPtr handle)
        {
            mscTraceLog.ViewLog();
        }

        #endregion static members
    }
}
