using System.Windows;
using System.Windows.Input;

namespace ClinSchd.Modules.ChangeDivision.ChangeDivision
{
    /// <summary>
	/// Interaction logic for ChangeDivisionView.xaml
    /// </summary>
	public partial class ChangeDivisionView : Window, IChangeDivisionView
    {
		public ChangeDivisionView ()
        {
            InitializeComponent();
            Owner = Infrastructure.Keys.MainWindow;
        }

		public ChangeDivisionPresentationModel Model
        {
            get
            {
				return this.DataContext as ChangeDivisionPresentationModel;
            }

            set
            {
                this.DataContext = value;
            }
        }

		private void Button_OK_Click(object sender, RoutedEventArgs e)
		{
			this.Model.ExecuteChangeDivisionCommand ("Change Division");

			if (this.Model.ValidationMessage.IsValid) {
				Close ();
			} else {
				this.Model.View.AlertUser (this.Model.ValidationMessage.Message, this.Model.ValidationMessage.Title);
			}
		}

		private void Button_Cancel_Click(object sender, RoutedEventArgs e)
		{
			Close();
		}

		private bool bDialogResult = false;
		public bool ConfirmUser (string message, string caption)
		{
            bDialogResult = Infrastructure.Keys.ConfirmUser(this, message, caption);
            return bDialogResult;
        }

		public void AlertUser (string message, string caption)
		{
            Infrastructure.Keys.AlertUser(this, message, caption);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
            DivisionListBox.Focus();
            Keyboard.Focus(DivisionListBox);
        }

        private void HotKeyHandler(object sender, KeyEventArgs e)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                Key key = e.Key == Key.System ? e.SystemKey : e.Key;
                switch (key)
                {
                    case Key.O:
                        Keyboard.Focus(OkButton);
                        break;
                    case Key.C:
                        Keyboard.Focus(CancelButton);
                        break;
                }
            }
        }
    }
}
