using System.Windows;
using System.Windows.Input;

namespace ClinSchd.Modules.CheckIn.CheckIn
{
    /// <summary>
    /// Interaction logic for CheckInView.xaml
    /// </summary>
    public partial class CheckInView : ICheckInView
    {
        public CheckInView ()
        {
            InitializeComponent();
            Owner = Infrastructure.Keys.MainWindow;
        }

        public CheckInPresentationModel Model
        {
            get { return DataContext as CheckInPresentationModel; }
            set { DataContext = value; }
        }

        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
        }

        private void Button_OK_Click(object sender, RoutedEventArgs e)
        {
            Model.ExecuteCheckInAppointmentCommand ("CheckIn Patient");

            if (Model.ValidationMessage.IsValid) {
                Close();
            } else {
                Model.View.AlertUser (Model.ValidationMessage.Message, Model.ValidationMessage.Title);
            }
            //Model.PromptToRemoveRequest(Model.PatientName);
        }

        private void Button_Cancel_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        public void Refresh ()
        {
        }

        private bool _bDialogResult;

        public bool ConfirmUser (string message, string caption)
        {
            _bDialogResult = Infrastructure.Keys.ConfirmUser(this, message, caption);
            return _bDialogResult;
        }   

        public void AlertUser (string message, string caption)
        {
            Infrastructure.Keys.AlertUser(this, message, caption);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
            OkButton.Focus();
            Keyboard.Focus(OkButton);
        }

        private void HotKeyHandler(object sender, KeyEventArgs e)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                Key key = e.Key == Key.System ? e.SystemKey : e.Key;
                switch (key)
                {
                    case Key.O:
                        Keyboard.Focus(OkButton);
                        break;
                    case Key.C:
                        Keyboard.Focus(CancelButton);
                        break;
                }
            }
        }
    }
}
