using Microsoft.Practices.Composite.Modularity;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Composite.Events;
using ClinSchd.Modules.CheckOut.CheckOut;
using ClinSchd.Modules.CheckOut.Controllers;
using ClinSchd.Modules.CheckOut.Services;

namespace ClinSchd.Modules.CheckOut
{
    public class CheckOutModule : IModule
    {
        private readonly IUnityContainer _container;
        private readonly IEventAggregator _eventAggregator;
        private ICheckOutController _controller;

        public CheckOutModule( IUnityContainer container, IEventAggregator eventAggregator )
        {
            _container = container;
            _eventAggregator = eventAggregator;
        }

        public void Initialize()
        {
            RegisterViewsAndServices();
            _controller = _container.Resolve<ICheckOutController>();
            _controller.Run();
        }

        protected void RegisterViewsAndServices()
        {
            _container.RegisterType<ICheckOutController, CheckOutController>();
            _container.RegisterType<ICheckOutView, CheckOutView>();
            _container.RegisterType<ICheckOutPresentationModel, CheckOutPresentationModel>();
            _container.RegisterType<ICheckOutService, CheckOutService>();
        }
    }
}
