﻿using ClinSchd.Modules.ContactAttempt.ContactAttempt;
using ClinSchd.Modules.ContactAttempt.Controllers;
using ClinSchd.Modules.ContactAttempt.Services;
using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Modularity;
using Microsoft.Practices.Unity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ClinSchd.Modules.ContactAttempt
{
    public class ContactAttemptModule : IModule
    {
        private readonly IUnityContainer _container;
        private readonly IEventAggregator _eventAggregator;
        private IContactAttemptController _controller;

        public ContactAttemptModule(IUnityContainer container, IEventAggregator eventAggregator)
        {
            _container = container;
            _eventAggregator = eventAggregator;
        }

        public void Initialize()
        {
            RegisterViewsAndServices();
            _controller = _container.Resolve<IContactAttemptController>();
            _controller.Run();
        }

        protected void RegisterViewsAndServices()
        {
            _container.RegisterType<IContactAttemptController, ContactAttemptController>();
            _container.RegisterType<IContactAttemptView, ContactAttemptView>();
            _container.RegisterType<IContactAttemptPresentationModel, ContactAttemptPresentationModel>();
            _container.RegisterType<IContactAttemptService, ContactAttemptService>();
        }
    }
}
