﻿using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.ExpandedEntry.ExpandedEntry;
using ClinSchd.Modules.ExpandedEntry.Services;
using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Presentation.Events;
using Microsoft.Practices.Unity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ClinSchd.Modules.ExpandedEntry.Controllers
{
    public class ExpandedEntryController : IExpandedEntryController
    {
        private readonly IExpandedEntryService _expandedEntryService;
        private readonly IEventAggregator _eventAggregator;
        private readonly IUnityContainer _container;

        public ExpandedEntryController(IUnityContainer container,
            IExpandedEntryService expandedEntryService,
            IEventAggregator eventAggregator)
        {
            this._expandedEntryService = expandedEntryService;
            this._eventAggregator = eventAggregator;
            this._container = container;
        }

        public void Run()
        {
            this._eventAggregator.GetEvent<LaunchExpandedEntryDialogEvent>().Subscribe(LaunchExpandedEntryDialog, ThreadOption.UIThread, true);
        }

        public void LaunchExpandedEntryDialog(Dictionary<string, string> patientIenAndAppointmentStartTime)
        {
            IExpandedEntryPresentationModel Model = _container.Resolve<IExpandedEntryPresentationModel>();            

            Model.LoadExpandedAppointmentProfile(patientIenAndAppointmentStartTime["IEN"], patientIenAndAppointmentStartTime["AppointmentStartTime"]);
            this._expandedEntryService.ShowDialog(Model.View, Model, () => Model.OnClose());

        }
    }
}
