﻿using ClinSchd.Infrastructure.Interfaces;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.ExpandedEntry.Mappings;
using ClinSchd.Modules.ExpandedEntry.Models;
using ClinSchd.Modules.ExpandedEntry.Services;
using Microsoft.Practices.Composite.Events;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace ClinSchd.Modules.ExpandedEntry.ExpandedEntry
{
    public class ExpandedEntryPresentationModel : IExpandedEntryPresentationModel, INotifyPropertyChanged
    {
        private readonly IExpandedEntryService _expandedEntryService;
        public readonly IDataAccessService _DataAccessService;
        public readonly IEventAggregator _EventAggregator;
        

        public ExpandedEntryPresentationModel(
            IExpandedEntryView view,
            IExpandedEntryService expandedEntryService,
            IDataAccessService dataAccessService,
            IEventAggregator eventAggregator)
        {
            _EventAggregator = eventAggregator;
            _expandedEntryService = expandedEntryService;
            _DataAccessService = dataAccessService;            
           
            View = view;
            View.Model = this;
            ValidationMessage = new ValidationMessage();
            InitialErrorMessage();
        }
        
        public ExpandedAppointmentProfile ExpandedAppointmentProfile { get; set; }

        public void LoadExpandedAppointmentProfile(string dfn, string fileManAppointmentDateTime)
        {
            this.ExpandedAppointmentProfile = 
                ExpandedEntryMapping.MapExpandedEntryFromRPC(_DataAccessService, dfn, fileManAppointmentDateTime); 
        }        

        #region VSE MODULE PATTERN PROPERTIES
        public IExpandedEntryView View { get; }

        public ValidationMessage ValidationMessage { get; set; }

        public void InitialErrorMessage()
        {
            ValidationMessage.IsValid = true;
            ValidationMessage.Title = string.Empty;
            ValidationMessage.Message = string.Empty;
        }

        public void OnClose()
        {
            View.Close();
        }
        #endregion

        #region PROPERTY CHANGED
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
                   
    }
}
