﻿using System;
using System.Windows;
using System.Windows.Input;
using System.Xaml;

namespace ClinSchd.Modules.ExpandedEntry.ExpandedEntry
{
    /// <summary>
    /// Interaction logic for ExpandedEntryView.xaml
    /// </summary>
    public partial class ExpandedEntryView : IExpandedEntryView
    {
        public ExpandedEntryView()
        {
            InitializeComponent();
            Owner = Infrastructure.Keys.MainWindow;
        }

        public ExpandedEntryPresentationModel Model
        {
            get
            {
                return DataContext as ExpandedEntryPresentationModel;
            }

            set
            {
                DataContext = value;
            }
        }

        public void AlertUser(string message, string caption)
        {
            throw new NotImplementedException();
        }

        public bool ConfirmUser(string message, string caption)
        {
            throw new NotImplementedException();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
        }

        private void HotKeyHandler(object sender, KeyEventArgs e)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                Key key = e.Key == Key.System ? e.SystemKey : e.Key;
                switch (key)
                {                    
                    case Key.C:
                        Keyboard.Focus(CloseButton);
                        break;
                }
            }
        }

        private void CloseButton_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }
    }
}
