﻿using ClinSchd.Modules.ExpandedEntry.Controllers;
using ClinSchd.Modules.ExpandedEntry.ExpandedEntry;
using ClinSchd.Modules.ExpandedEntry.Services;
using ClinSchd.Modules.MarkAsNoShow.Controllers;
using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Modularity;
using Microsoft.Practices.Unity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ClinSchd.Modules.ExpandedEntry
{
    public class ExpandedEntryModule : IModule
    {
        private readonly IUnityContainer container;
        private readonly IEventAggregator eventAggregator;
        private IExpandedEntryController controller;

        public ExpandedEntryModule(IUnityContainer container, IEventAggregator eventAggregator)
        {
            this.container = container;
            this.eventAggregator = eventAggregator;
        }

        public void Initialize()
        {
            this.RegisterViewsAndServices();
            controller = this.container.Resolve<IExpandedEntryController>();
            controller.Run();
        }

        protected void RegisterViewsAndServices()
        {
            this.container.RegisterType<IExpandedEntryController, ExpandedEntryController>();
            this.container.RegisterType<IExpandedEntryView, ExpandedEntryView>();
            this.container.RegisterType<IExpandedEntryPresentationModel, ExpandedEntryPresentationModel>();
            this.container.RegisterType<IExpandedEntryService, ExpandedEntryService>();
        }
    }
}
