using System;

using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Regions;

using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.FindAppt.CancelMRTC;
using ClinSchd.Modules.FindAppt.Services;
using ClinSchd.Modules.FindAppt.FindAppt;

namespace ClinSchd.Modules.FindAppt.Controllers
{
	public class FindApptController : IFindApptController
	{
		private IFindApptPresentationModel FindApptPresentationModel;
		private readonly IFindApptService FindApptService;
		private readonly IEventAggregator eventAggregator;

		public FindApptController (
			IFindApptService FindApptService,
			IEventAggregator eventAggregator)
		{
			this.FindApptService = FindApptService;
			this.eventAggregator = eventAggregator;
		}

		public IFindApptPresentationModel Model
        {
            get { return this.FindApptPresentationModel; }
            set { this.FindApptPresentationModel = value; }
        }

		public void Run()
		{
			this.FindApptService.ShowDialog (
				this.FindApptPresentationModel.View, eventAggregator,
				this.FindApptPresentationModel, () => FindApptPresentationModel.OnClose ());
		}

        public bool RunMRTCCancel(IConfirmCloseMRTCRequestPresentationModel model)
        {
            return this.FindApptService.ShowMRTCCancelDialog(model);
        }
	}
}
