using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Animation;
using Telerik.Windows.Controls;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Management.AccessGroups
{
    /// <summary>
	/// Interaction logic for AccessGroupsView.xaml
    /// </summary>
	public partial class AccessGroupsView : RadPane, IAccessGroupsView
    {
		public AccessGroupsView()
        {
            InitializeComponent();
        }

		public AccessGroupsPresentationModel Model
        {
            get
            {
				return this.DataContext as AccessGroupsPresentationModel;
            }

            set
            {
                this.DataContext = value;
            }
        }

		private bool bDialogResult = false;
		public bool ConfirmUser (string message, string caption)
		{
            bDialogResult = Infrastructure.Keys.ConfirmUser(this, message, caption);
            return bDialogResult;
        }   

		public void AlertUser (string message, string caption)
		{
            Infrastructure.Keys.AlertUser(this, message, caption);
        }

		private void NewType_Click (object sender, RoutedEventArgs e)
		{
			this.Model.ExecuteAddAccessTypeCommand (string.Empty);
		}

		private void EditType_Click (object sender, RoutedEventArgs e)
		{
			this.Model.ExecuteEditAccessTypeCommand (string.Empty);
		}

		private void NewGroup_Click (object sender, RoutedEventArgs e)
		{
			this.Model.ExecuteAddAccessGroupCommand (string.Empty);
		}

		private void EditGroup_Click (object sender, RoutedEventArgs e)
		{
			this.Model.ExecuteEditAccessGroupCommand (string.Empty);
		}

		private void RemoveGroup_Click (object sender, RoutedEventArgs e)
		{
			this.Model.RemoveGroupByID ();			
		}

		private void AccessGroupListBox_SelectionChanged (object sender, SelectionChangedEventArgs e)
		{
			this.Model.LoadGroupedAccessTypes ();
		}

		private void AddType_Click (object sender, RoutedEventArgs e)
		{
			this.Model.AddAccessTypeToGroup ();
		}

		private void AddAll_Click (object sender, RoutedEventArgs e)
		{
			this.Model.AddAllAccessTypesToGroup ();
		}

		private void RemoveType_Click (object sender, RoutedEventArgs e)
		{
			this.Model.RemoveGroupedAccessType ();
		}

		private void RemoveAll_Click (object sender, RoutedEventArgs e)
		{
			this.Model.RemoveAllGroupedAccessTypes ();
		}

        private void AccessTypes_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

            if (e.AddedItems.Count > 0)
            {
                SchdAccessType accessType = e.AddedItems[0] as SchdAccessType;
                Model.AccessTypeIEN = accessType.BSDX_ACCESS_TYPE_IEN;
            }

            

        }

	}
}
