using System;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;

namespace ClinSchd.Modules.Management.AddAccessType
{
    /// <summary>
	/// Interaction logic for AddAccessTypeView.xaml
    /// </summary>
	public partial class AddAccessTypeView : Window, IAddAccessTypeView
    {
		public AddAccessTypeView()
        {
            InitializeComponent();
            Owner = Infrastructure.Keys.MainWindow;
        }

		public AddAccessTypePresentationModel Model
        {
            get
            {
				return this.DataContext as AddAccessTypePresentationModel;
            }

            set
            {
                this.DataContext = value;
            }
        }
		public RadColorPicker AccessTypeColorPicker
		{
			get
			{
				return this.colorPicker;
			}

			set
			{
				this.colorPicker = value;
			}
		}

		public TextBox ATName
		{
			get
			{
				return this.AccessTypeName;
			}

			set
			{
				this.AccessTypeName = value;
			}
		}

		protected override void OnClosing (System.ComponentModel.CancelEventArgs e)
		{
			this.Visibility = Visibility.Hidden;
			e.Cancel = true;
		}

		private void CancelButton_Click (object sender, RoutedEventArgs e)
		{
			Close ();
		}

		private void OkButton_Click (object sender, RoutedEventArgs e)
		{
			this.Model.AddEditAccessType ();
			if (this.Model.ValidationMessage.IsValid) {
				Close ();
			} else {
				this.Model.View.AlertUser (this.Model.ValidationMessage.Message, this.Model.ValidationMessage.Title);
			}
		}

		private void RadColorPicker_SelectedColorChanged (object sender, EventArgs e)
		{
			if (AccessTypeName.Text != null) {
				this.AccessTypeName.Foreground = new SolidColorBrush ((sender as RadColorPicker).SelectedColor);
			}
		}

		private void RadColorPicker_MouseLeftButtonDown (object sender, System.Windows.Input.MouseButtonEventArgs e)
		{
			if (AccessTypeName.Text != null) {
				this.AccessTypeName.Foreground = new SolidColorBrush ((sender as RadColorPicker).SelectedColor);
			}
		}

		private void RadColorPicker_Click (object sender, EventArgs e)
		{
			if (AccessTypeName.Text != null) {
				this.AccessTypeName.Foreground = new SolidColorBrush ((sender as RadColorPicker).SelectedColor);
			}
		}

		private bool bDialogResult = false;
		public bool ConfirmUser (string message, string caption)
		{
            bDialogResult = Infrastructure.Keys.ConfirmUser(this, message, caption);
            return bDialogResult;
        }   

		public void AlertUser (string message, string caption)
		{
            Infrastructure.Keys.AlertUser(this, message, caption);
        }

        private void paneManagementAddAccessType_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
        }

        private void HotKeyHandler(object sender, KeyEventArgs e)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                Key key = e.Key == Key.System ? e.SystemKey : e.Key;
                switch (key)
                {
                    case Key.O:
                        Keyboard.Focus(OkButton);
                        break;
                    case Key.C:
                        Keyboard.Focus(CancelButton);
                        break;
                }
            }
        }
    }
}
