using System.Windows;
using System.Windows.Controls;

namespace ClinSchd.Modules.Management.AddResource
{
    /// <summary>
    /// Interaction logic for AddResourceView.xaml
    /// </summary>
    public partial class ResourceWaitlistView : IResourceWaitlistView
    {
        public ResourceWaitlistView()
        {
            InitializeComponent();
        }

        public ResourceWaitlistPresentationModel Model
        {
            get { return DataContext as ResourceWaitlistPresentationModel; }
            set { DataContext = value; }
        }

        protected override void OnClosing (System.ComponentModel.CancelEventArgs e)
        {
            Visibility = Visibility.Hidden;
            e.Cancel = true;
        }

        private void CancelButton_Click (object sender, RoutedEventArgs e)
        {
            Close ();
        }

        private bool _bDialogResult;
        public bool ConfirmUser (string message, string caption)
        {
            _bDialogResult = Infrastructure.Keys.ConfirmUser(this, message, caption);
            return _bDialogResult;
        }   

        public void AlertUser (string message, string caption)
        {
            Infrastructure.Keys.AlertUser(this, message, caption);
        }

        private void RPMSClinicName_SelectionChanged (object sender, SelectionChangedEventArgs e)
        {
            if (Model.HospitalLocationID != null) {
                Model.LoadClinicSetupParemters ();
            }
        }

        private void OK_Click (object sender, RoutedEventArgs e)
        {
            Close ();
        }
    }
}
