using Microsoft.Practices.Unity;
using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Presentation.Events;
using Microsoft.Practices.Composite.Regions;

using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.Management.ReactivateResource;
using ClinSchd.Modules.Management.ReactivateResource.Services;

namespace ClinSchd.Modules.Management.ReactivateResource.Controllers
{
    public class ManagementReactivateResourceController : IManagementReactivateResourceController
    {
		private readonly IUnityContainer container;
		private readonly IRegionManager regionManager;
		private IReactivateResourcePresentationModel reactivateResourcePresentationModel;
        private readonly IEventAggregator eventAggregator;
		private IManagementReactivateResourceService managementReactivateResourceService;

		public ManagementReactivateResourceController(
			IUnityContainer container,
			IRegionManager regionManager,
			IEventAggregator eventAggregator,
			IManagementReactivateResourceService managementReactivateResourceService,
			IReactivateResourcePresentationModel reactivateResourcePresentationModel)
        {
			this.container = container;
			this.regionManager = regionManager;
            this.eventAggregator = eventAggregator;
			this.managementReactivateResourceService = managementReactivateResourceService;
			this.reactivateResourcePresentationModel = reactivateResourcePresentationModel;
		}

		public IReactivateResourcePresentationModel Model { get { return this.reactivateResourcePresentationModel; } }

        public void Run()
        {
			this.managementReactivateResourceService.ShowDialog (this.reactivateResourcePresentationModel.View,
														this.reactivateResourcePresentationModel, () => reactivateResourcePresentationModel.OnClose ());
		}
    }

}
