using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Regions;
using ClinSchd.Modules.Management.Group;
using ClinSchd.Modules.Management.Services;

namespace ClinSchd.Modules.Management.Controllers
{
    public class ManagementController : IManagementController
    {
        private readonly IRegionManager _regionManager;
        private readonly IGroupPresentationModel _groupPresentationModel;
        private readonly IEventAggregator _eventAggregator;
        private readonly IManagementService _managementService;

        public ManagementController (IRegionManager regionManager, 
                                IGroupPresentationModel groupPresentationModel, 
                                IEventAggregator eventAggregator,
                                IManagementService managementService)
        {
            _regionManager = regionManager;
            _groupPresentationModel = groupPresentationModel;
            _eventAggregator = eventAggregator;
            _groupPresentationModel.Controller = this;
            _managementService = managementService;
        }

        public IGroupPresentationModel Model { get { return _groupPresentationModel; } }

        public void Run()
        {
            _managementService.ShowDialog (_groupPresentationModel.View, _groupPresentationModel, () => _groupPresentationModel.OnClose ());
        }
    }
}
