﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Interfaces;

namespace ClinSchd.Modules.Management.Views
{
    /// <summary>
    /// Interaction logic for UpdateResourceUsersView.xaml
    /// </summary>
    public partial class UpdateResourceUsersView : UserControl
    {
        private IDataAccessService _dataAccessService;
        System.Windows.Threading.DispatcherTimer dispatcherTimer = new System.Windows.Threading.DispatcherTimer();
        public UpdateResourceUsersView(IDataAccessService dataAccessService)
        {
            InitializeComponent();
            _dataAccessService = dataAccessService;
            dispatcherTimer.Tick += dispatcherTimer_Tick;
            dispatcherTimer.Interval = new TimeSpan(0, 0, 1);
        }

        private int _ctr = 0;
        private void dispatcherTimer_Tick(object sender, EventArgs e)
        {
            _ctr++;
            if (_ctr == 1)
            {
                UpdateResourceUsers();
                dispatcherTimer.Stop();
            }
            // code goes here
        }

        private void UpdateResourceUsers()
        {
            //Keys.Tables.ProhibitedClinicsAndUsers = _dataAccessService.GetProhibitedClincs();

            Thread.Sleep(250);

            var window = Window.GetWindow(this);
            if (window != null)
                window.Close();
        }

        private void UpdateResourceUsers_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
            dispatcherTimer.Start();
        }
    }
}
