﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace ClinSchd.Modules.Navigation.ViewModels
{
    public class PatientContactViewModel : INotifyPropertyChanged
    {
        private DateTime _contactDateTime;

        public DateTime ContactDateTime
        {
            get
            {
                if ( _contactDateTime == DateTime.MinValue )
                    return DateTime.Now;
                return _contactDateTime;
            }
            set
            {
                if ( _contactDateTime == value )
                    return;
                _contactDateTime = value;
                OnPropertyChanged( "ContactDateTime" );
            }
        }

        private string _contactPhoneNumber;

        public string ContactPhoneNumber
        {
            get { return _contactPhoneNumber; }
            set
            {
                if ( _contactPhoneNumber == value )
                    return;
                _contactPhoneNumber = value;
                OnPropertyChanged( "ContactPhoneNumber" );
            }
        }

        private bool _leftMessage;

        public bool LeftMessage
        {
            get { return _leftMessage; }
            set
            {
                if ( _leftMessage == value )
                    return;
                _leftMessage = value;
                OnPropertyChanged( "LeftMessage" );
            }
        }

        private bool _noAnswer;

        public bool NoAnswer
        {
            get { return _noAnswer; }
            set
            {
                if ( _noAnswer == value )
                    return;
                _noAnswer = value;
                OnPropertyChanged( "NoAnswer" );
            }
        }

        private bool _numberNoLongerInService;

        public bool NumberNoLongerInService
        {
            get { return _numberNoLongerInService; }
            set
            {
                if ( _numberNoLongerInService == value )
                    return;
                _numberNoLongerInService = value;
                OnPropertyChanged( "NumberNoLongerInService" );
            }
        }

        private bool _contactMade;

        public bool ContactMade
        {
            get { return _contactMade; }
            set
            {
                if ( _contactMade == value )
                    return;
                _contactMade = value;
                OnPropertyChanged( "ContactMade" );
            }
        }

        private string _comments;
        public string Comments
        {
            get { return _comments; }
            set
            {
                if (_comments == value)
                    return;
                _comments = value;
                OnPropertyChanged("Comments");
            }
        }

        public List<string> PatientContactStatusValues
        {
            get { return new List<string>( new[] {"Left Message", "No Answer", "Number no Longer in Service", "Contacted"} ); }
        }


        private string _patientContactStatus;
        public string PatientContactStatus
        {
            get { return _patientContactStatus; }
            set 
            {
                _patientContactStatus = value;
                OnPropertyChanged("PatientContactStatus");
            }
        }

        public void OnPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
