﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace ClinSchd.Modules.Navigation.Views
{
    /// <summary>
    /// Interaction logic for ReqMngmtBrowser.xaml
    /// </summary>
    public partial class ReqMngmtBrowser : UserControl
    {
        public ReqMngmtBrowser()
        {
            InitializeComponent();
            var uri = new System.Uri("http://www.hp.com");
            RequestManagementBrowser.Navigate(uri);
        }
        /*private void txtUrl_KeyUp(object sender, KeyEventArgs e)
        {
            var uri = new Uri(TxtUrl.Text);
            if (e.Key == Key.Enter)
                RequestManagementBrowser.Navigate(uri);
        }*/

        private void wbSample_Navigating(object sender, System.Windows.Navigation.NavigatingCancelEventArgs e)
        {
            TxtUrl.Text = e.Uri.OriginalString;
        }

        private void BrowseBack_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = ((RequestManagementBrowser != null) && (RequestManagementBrowser.CanGoBack));
        }

        private void BrowseBack_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            RequestManagementBrowser.GoBack();
        }

        private void BrowseForward_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = ((RequestManagementBrowser != null) && (RequestManagementBrowser.CanGoForward));
        }

        private void BrowseForward_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            RequestManagementBrowser.GoForward();
        }

        private void BrowseRefresh_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            RequestManagementBrowser.Refresh();
        }

        private void GoToPage_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = true;
        }

        private void GoToPage_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            if (TxtUrl.Text.Substring(0, 4) != "http")
                TxtUrl.Text = "http://" + TxtUrl.Text;
            var uri = new Uri(TxtUrl.Text);
            RequestManagementBrowser.Navigate(uri);
        }

        private void TxtUrl_GotFocus(object sender, RoutedEventArgs e)
        {
            var textBox = e.OriginalSource as TextBox;
            if (textBox != null)
            {
                Keyboard.Focus(textBox);
                textBox.SelectAll();
            }  
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
        }
    }
}
