﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using ClinSchd.Infrastructure.Interfaces;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.Navigation.Group;
using ClinSchd.Modules.Navigation.ViewModels;
//using mscOVID.Domain.Mock;

namespace ClinSchd.Modules.Navigation.Views
{
    /// <summary>
    /// Interaction logic for WaitListDisposition.xaml
    /// </summary>
    public partial class WaitListDisposition : UserControl
    {
        public bool DialogResult { get; set; }
        public WaitListDispositionViewModel WaitListDispositionViewModel { get; set; }
        public Patient PatientToRemove;
        public AppointmentRequest RequestToRemove;
        private OVIDDataTableRepository _adt;
        public WaitListDisposition()
        {
            InitializeComponent();
            WaitListDispositionViewModel = new WaitListDispositionViewModel();
            this.DataContext = WaitListDispositionViewModel;
        }

        private void OK_Click(object sender, RoutedEventArgs e)
        {
            _adt = OVIDDataTableRepository.Instance;
            if (DispositionList.SelectedItem == null)
            {
                MessageBox.Show("Please select a Disposition");
                return;
            }

            var disposition = DispositionList.SelectedItem.ToString();
            var parms = new List<string> { RequestToRemove.RequestManagmentIen, disposition };
            //_adt.callOVIDRPC("BSDX MSC SD WL CLOSE", parms);
            _adt.callOVIDRPC("SDEC WLCLOSE", parms);
            DialogResult = true;
            var window = Window.GetWindow(this);
            if (window != null)
                window.Close();
        }

        private void Cancel_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
            var window = Window.GetWindow(this);
            if (window != null)
                window.Close();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
        }
    }
}
