﻿using System;
using System.Windows;

namespace ClinSchd.Modules.PatientAppt.ChildModules.Disabilities.Disabilities
{
    /// <summary>
    /// Interaction logic for DisabilitiesView.xaml
    /// </summary>
    public partial class DisabilitiesView : Window, IDisabilitiesView
    {
        public DisabilitiesView(IDisabilitiesPresentationModel model)
        {
            InitializeComponent();
            Model = model;
            Model.View = this;
        }

        public IDisabilitiesPresentationModel Model
        {
            get { return DataContext as DisabilitiesPresentationModel; }
            set { DataContext = value; }
        }

        public new Window Owner
        {
            get { return base.Owner; }
            set { base.Owner = value; }
        }

        #region Event Handler members

        private void OnClosed(object sender, EventArgs e)
        {
            Model.Close();
            Model = null;
        }

        #endregion Event Handler members

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
        }
    }
}
