﻿using Microsoft.Practices.Composite.Modularity;
using Microsoft.Practices.Unity;
using ClinSchd.Modules.PatientAppt.ChildModules.Disabilities.Controllers;
using ClinSchd.Modules.PatientAppt.ChildModules.Disabilities.Disabilities;
using ClinSchd.Modules.PatientAppt.ChildModules.Disabilities.Services;

namespace ClinSchd.Modules.PatientAppt.ChildModules.Disabilities
{
    public class DisabilitiesModule : IModule
    {
        private readonly IUnityContainer _container;

        public DisabilitiesModule(IUnityContainer container)
        {
            _container = container;
        }

        public void Initialize()
        {
            RegisterViewsAndServices();

            IDisabilitiesController controller = _container.Resolve<IDisabilitiesController>();
            controller.Run();
        }

        protected void RegisterViewsAndServices()
        {
            _container.RegisterType<IDisabilitiesController, DisabilitiesController>(new ContainerControlledLifetimeManager());
            _container.RegisterType<IDisabilitiesService, DisabilitiesService>(new ContainerControlledLifetimeManager());
            _container.RegisterType<IDisabilitiesPresentationModel, DisabilitiesPresentationModel>();
            _container.RegisterType<IDisabilitiesView, DisabilitiesView>();            
        }
    }
}
