using ClinSchd.Modules.PatientAppt.Controllers;
using ClinSchd.Infrastructure.Models;
using Microsoft.Practices.Composite.Presentation.Events;
using System.Collections.Generic;
using ClinSchd.Modules.PatientAppt.Group.BenefitEligibility;

namespace ClinSchd.Modules.PatientAppt.Group
{
    public interface IGroupPresentationModel
    {
        IGroupView View { get; }
        IPatientApptController Controller { get; set; }
        PatientInformation PatientInformation { get; set; }
        AppointmentData AppointmentData { get; set; }
        ValidationMessage ValidationMessage { get; set; }
        AppointmentRequest AppointmentRequest { get; set; }
        void GetEditAppointment (SchdAppointment newAppointment);
        void GetViewAppointment (SchdAppointment newAppointment);
        void GetWalkInAppointment(SchdAppointment newAppointment, bool isOverbook = false);
        void GetNewAppointment (SchdAppointment newAppointment, bool isOverbook = false);
        void GetPatientInformation (string patientIEN);
        string PaneTitle { get; set; }
        CompositePresentationEvent<string> NewForwardingEvent { get; set; }
        void OnClose ();
        string Command { get; set; }
        bool IsNoteEnabled { get; set; }
        bool IsDurationEnabled { get; }
        void OnPropertyChanged (string propertyName);

        List<Eligibility> PatientEligibilitiesList { get; set; }
    }
}
