﻿using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Text.RegularExpressions;

using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.PatientSelection.PatientSelection.ChildModules.PatientDemographics
{
        /// <summary>
    /// Interaction logic for PatientInformation.xaml
    /// </summary>
    public partial class PatientInformation : IPatientInformation
    {
        public PatientInformation()
        {
            InitializeComponent();
        }

        // This handles my bindings
        public IPatientInformationPresentationModel Model
        {
            get { return DataContext as PatientInformationPresentationModel; }
            set { DataContext = value; }
        }

        private void PatientInformationDialog_Loaded(object sender, RoutedEventArgs e)
        {
        }

        private void PatientInformationDialog_unloaded(object sender, RoutedEventArgs e)
        {
        }

        public bool DialogResult { get; set; }

        private void OK_Click(object sender, RoutedEventArgs e)
        {
            if (Model.SavePatientData())
            {
                DialogResult = true;
                CloseThisWindow();
            }
        }

        private void Cancel_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
            CloseThisWindow();
        }

        private void PhoneValidationTextBox(object sender, TextCompositionEventArgs e)
        {
            e.Handled = !Keys.Methods.VALID_PHONE_INPUT.Contains(e.Text);
        }

        private void MobilePhoneValidationTextBox(object sender, TextCompositionEventArgs e)
        {
            e.Handled = !Keys.Methods.VALID_MOBILE_PHONE_INPUT.Contains(e.Text);
        }

        private void NumberValidationTextBox(object sender, TextCompositionEventArgs e)
        {
            Regex regex = new Regex("[^0-9]+");
            e.Handled = regex.IsMatch(e.Text);
        }

        private void CloseThisWindow()
        {
            var window = Window.GetWindow(this);
            if (window != null)
                window.Close();
            Thread.Sleep(200);
        }

        private void HotKeyHandler(object sender, KeyEventArgs e)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                Key key = e.Key == Key.System ? e.SystemKey : e.Key;
                switch (key)
                {
                    case Key.O:
                        Keyboard.Focus(BtnOk);
                        break;
                    case Key.C:
                        Keyboard.Focus(BtnCancel);
                        break;
                }
            }
        }

        private void ListView1_PreviewKeyUp(object sender, KeyEventArgs e)
        {
            if ((ListView1.SelectedItem != null) && (e.Key == Key.Space) && (Keyboard.Modifiers == ModifierKeys.None))
            {
                Race race = (Race)ListView1.SelectedItem;
                race.IsSelected = !race.IsSelected;

                e.Handled = true; //this is necessary because otherwise when the checkbox cell is selected, it will apply this keyup and also apply the default behavior for the checkbox
            }
        }
    }
}
