using System.Collections.Generic;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.PatientSelection.PatientSelection.ChildModules.PatientDemographics;

namespace ClinSchd.Modules.PatientSelection.PatientSelection
{
    public interface IPatientInformationPresentationModel
    {
        void SetPatient( string patientIEN );

        Patient SelectedPatient { get; }
        IPatientInformation View { get; }
        string Command { get; set; }

        void OnClose();

        MaritalStatus SelectedMaritalStatus { get; set; }
        IList<MaritalStatus> MaritalStatusList { get; }
        string Gender { get; }
        bool IsBadAddress { get; set; }
        bool BadAddressEnabled { get; }
        string PriorityGrouping { get; }
        IList<Ethnicity> EthnicityList { get; }
        Ethnicity SelectedEthnicity { get; set; }
        IList<Religion> ReligionList { get; }
        Religion SelectedReligion { get; set; }
        Race SelectedRace { get; set; }

        //ObservableCollection<Race> RaceList { get; }
        //IList<State> StateList { get; }

        IList<Country> CountryList { get; }
        bool DialogResult { get; }

        bool SavePatientData();

        void UpdatePrimaryContactLinkedInfo( string zipcode );
        void UpdateTemporaryContactLinkedInfo( string zipcode );

        void InitializeStateValues();
    }
}