using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace ClinSchd.Modules.PatientSelection.PatientSelection
{
    /// <summary>
    /// Interaction logic for PatientSelectionView.xaml
    /// </summary>
    public partial class PatientSelectionView : IPatientSelectionView
    {
        public PatientSelectionView()
        {
            InitializeComponent();
            Owner = Infrastructure.Keys.MainWindow;
        }

        public PatientSelectionPresentationModel Model
        {
            get { return DataContext as PatientSelectionPresentationModel; }
            set { DataContext = value; }
        }

        protected override void OnClosing( System.ComponentModel.CancelEventArgs e )
        {
        }

        private void PatientSelection_MouseDoubleClick( object sender, System.Windows.Input.MouseButtonEventArgs e )
        {
            Model.SelectedPatient = Model.PatientFactory.Create();
            Model.NewAppointmentCommand.Execute( Model.SelectedPatient.IEN );
            Close();
        }

        private void Button_OK_Click( object sender, RoutedEventArgs e )
        {
            Model.SelectedPatient = Model.PatientFactory.Create();
            Model.NewAppointmentCommand.Execute( Model.SelectedPatient.IEN );
            Close();
        }

        private void Button_Cancel_Click( object sender, RoutedEventArgs e )
        {
            DialogResult = false;
            Model.SelectedPatient = null;
            Close();
        }

        private void PatientSelection_TextChanged( object sender, TextChangedEventArgs e )
        {
            if ( sender is TextBox )
            {
                Model.SearchStringChanged( ( (TextBox)sender ).Text );
            }
        }

        private void Window_Loaded( object sender, RoutedEventArgs e )
        {
            Infrastructure.Keys.SetRenderingMode( this );
        }

        private void HotKeyHandler(object sender, KeyEventArgs e)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                Key key = e.Key == Key.System ? e.SystemKey : e.Key;
                switch (key)
                {
                    case Key.O:
                        Keyboard.Focus(OkButton);
                        break;
                    case Key.C:
                        Keyboard.Focus(CancelButton);
                        break;
                }
            }
        }
    }
}