using System;
using ClinSchd.Infrastructure;
using ClinSchd.Modules.PatientSelection.PatientSelection;

namespace ClinSchd.Modules.PatientSelection.Services
{
    public class PatientSelectionService : IPatientSelectionService
    {
        #region IPatientSelection Members

        public void ShowDialog<PatientSelectionPresentationModel>
            (IPatientSelectionView view, PatientSelectionPresentationModel viewModel, Action onDialogClose)
        {
            view.DataContext = viewModel;
            if (onDialogClose != null)
            {
                view.Closed += (sender, e) => onDialogClose();
            }
            view.ShowDialog();
        }
        public void ShowDemographicEditor(string command, IPatientInformationPresentationModel model)
        {
            if (model == null)
                return;

            CLaunchWindow.LaunchWindow(model.View, "Patient Info", 600, 670, "PatientPrompts", true, true, false, true, System.Windows.Media.Brushes.BlanchedAlmond);
        }
        #endregion
    }
}
