﻿
using ClinSchd.Infrastructure;
using System;
using System.ComponentModel;
using System.Windows;
using System.Windows.Input;
using System.Xaml;

namespace ClinSchd.Modules.Prerequisites.Prerequisites
{
    /// <summary>
    /// Interaction logic for PrerequisitesView.xaml
    /// </summary>
    public partial class PrerequisitesView : Window, IPrerequisitesView
    {
        public PrerequisitesView()
        {
            InitializeComponent();
            Owner = Infrastructure.Keys.MainWindow;
            Closing += OnWindowClosing; 
        }

        public PrerequisitesPresentationModel Model
        {
            get
            {
                return DataContext as PrerequisitesPresentationModel;
            }

            set
            {
                DataContext = value;
            }
        }

        public void AlertUser(string message, string caption)
        {
            Keys.AlertUser(this, message, caption);
        }

        public bool ConfirmUser(string message, string caption)
        {
            throw new NotImplementedException();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
        }

        private void HotKeyHandler(object sender, KeyEventArgs e)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                Key key = e.Key == Key.System ? e.SystemKey : e.Key;
                switch (key)
                {
                    case Key.C:
                        Keyboard.Focus(CloseButton);
                        break;
                }
            }
        }

        private void CloseButton_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        public void OnWindowClosing(object sender, CancelEventArgs e)
        {
            if (Keys.PrerequisiteWindowRequestIen == Model.AppointmentRequest.ApptRequestIen)
                Keys.PrerequisiteWindowRequestIen = 0;
        }
    }
}
