﻿using ClinSchd.Modules.Prerequisites.Controllers;
using ClinSchd.Modules.Prerequisites.Prerequisites;
using ClinSchd.Modules.Prerequisites.Services;
using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Modularity;
using Microsoft.Practices.Unity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ClinSchd.Modules.Prerequisites
{
    public class PrerequisitesModule : IModule
    {
        private readonly IUnityContainer _container;
        private readonly IEventAggregator _eventAggregator;
        private IPrerequisitesController _controller;

        public PrerequisitesModule(IUnityContainer container, IEventAggregator eventAggregator)
        {
            _container = container;
            _eventAggregator = eventAggregator;
        }

        public void Initialize()
        {
            RegisterViewsAndServices();
            _controller = _container.Resolve<IPrerequisitesController>();
            _controller.Run();
        }

        protected void RegisterViewsAndServices()
        {
            _container.RegisterType<IPrerequisitesController, PrerequisitesController>();
            _container.RegisterType<IPrerequisitesPresentationModel, PrerequisitesPresentationModel>();
            _container.RegisterType<IPrerequisitesView, PrerequisitesView>();
            _container.RegisterType<IPrerequisitesService, PrerequisiteService>();
        }
    }
}
