﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Linq;
using System.Windows;
using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Interfaces;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.DataAccess.Services;

using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Charting;
namespace ClinSchd.Modules.Reports.Reports
{
    public class ClinicReportViewModel
    {
        private readonly IDataAccessService _dataAccessService = new DataAccessService();
        private ObservableCollection<ClinicRecord> _clinicRecords = new ObservableCollection<ClinicRecord>();
        public ClinicReportViewModel()
        {
            GetClinicData();
        }
        
        public ObservableCollection<ClinicRecord> ClinicRecords
        {
            get { return _clinicRecords; }
            set { _clinicRecords = value; }
        }

        public void GetClinicData()
        {
            _clinicRecords.Clear();
            DataTable dt = _dataAccessService.GetClinicData();
            
                       
                foreach (DataRow row in dt.Rows)
                {
                    var clinicRec = new ClinicRecord();



                    clinicRec.Clinic = row["CLINNAME"].ToString();
                    clinicRec.Division = row["DIVNAME"].ToString();
                    clinicRec.StopCode = row["STOP_CODE_NUMBER"].ToString();
                    clinicRec.Service = row["SERVICE"].ToString();
                    clinicRec.ApptLength = row["APPTLEN"].ToString();
                    clinicRec.Variable = row["VAPPTLEN"].ToString();
                    clinicRec.InactiveDT = row["INACTIVATE_DT"].ToString();
                    clinicRec.ReactiveDT = row["REACTIVATE_DT"].ToString();
                    clinicRec.AppType = row["DEF-APPT-TYPE_NAME"].ToString();
                    clinicRec.Providers = row["PROVIDERS"].ToString();
                    clinicRec.CreateDT = row["DATE"].ToString();

                    _clinicRecords.Add(clinicRec);
                }
        }

    }
}
