﻿using System;
using System.Windows;
using System.Windows.Input;
using System.Windows.Threading;
using ClinSchd.Infrastructure.Interfaces;

namespace ClinSchd.Modules.Reports.Reports
{
    /// <summary>
    /// Interaction logic for EncounterReportConsole.xaml
    /// </summary>
    public partial class EncounterReportDashboardView
    {
        public EncounterReportDashboardViewModel ViewModel { get; }

        public EncounterReportDashboardView(IDataAccessService dataAccessService)
        {
            InitializeComponent();
            ViewModel = new EncounterReportDashboardViewModel(dataAccessService, this);
            DataContext = ViewModel;
        }

        public void CloseWindow()
        {
            var window = Window.GetWindow(this);
            if (window != null)
                window.Close();
        }

        public void Refresh()
        {
            Dispatcher.Invoke(DispatcherPriority.Send, (Action)delegate { });
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            Infrastructure.Keys.SetRenderingMode(this);
        }

        private void HoKeyHandler(Key k)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                switch (k)
                {
                    case Key.S:
                        Keyboard.Focus(BtnSubmit);
                        break;
                    case Key.C:
                        Keyboard.Focus(BtnClose);
                        break;
                    case Key.T:
                        Keyboard.Focus(CmbBxReportType);
                        break;
                    case Key.D:
                        Keyboard.Focus(CmbBxDateAgg);
                        break;
                    case Key.R:
                        Keyboard.Focus(CmbBxDateRange);
                        break;
                }

            }
        }

        private void UserControl_PreviewKeyUp(object sender, KeyEventArgs e)
        {
            Key key = e.Key == Key.System ? e.SystemKey : e.Key;
            HoKeyHandler(key);
        }

    }
}
