﻿using System;
using System.Collections.Generic;
using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Interfaces;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.DataAccess.Services;

namespace ClinSchd.Modules.Reports.Reports
{
    public class NonPatientsDisplayViewModel : AsyncValidatableModel
    {
        public IList<NonDisplayPatientRequest> NonDisplayPatientRequests
        {
            get { return _nonDisplayPatientRequests; }
            set
            {
                _nonDisplayPatientRequests = value;
                NotifyPropertyChanged( "NonDisplayPatientRequests" );
            }
        }

        public IDataAccessService DataAccessService;
        private IList<Patient> _patientList;
        private IList<NonDisplayPatientRequest> _nonDisplayPatientRequests;

        public IList<DisabledClinic> DisabledClinics { get; }

        public string SelectedPatient { get; set; }
        public NonPatientsDisplayViewModel(IDataAccessService dataAccessService)
        {
            DataAccessService = dataAccessService;
            DisabledClinics = DataAccessService.GetDisabledClinics();
        }

        public IList<string> PatientListStr { get; set; }

        public IList<Patient> PatientList
        {
            get { return _patientList; }
            set
            {
                if ( _patientList != value )
                {
                    _patientList = value;
                    NotifyPropertyChanged( "PatientList" );
                }
            }
        }

        public bool GetHiddenRecords(string inputType, string input)
        {
            return true;
        }
        public void SearchStringChanged(string newSearchString)
        {
            if (_patientList != null)
                _patientList.Clear();
            if (newSearchString == null)
                return;

            if (newSearchString.Length < Keys.PatientSearchCharMin)
                return;

            Patient tempPatient = new Patient( DataAccessService )
            {
                IsAsync = false
            };
            Dispatcher.Invoke((Action)(() => tempPatient.GetPatients(newSearchString, (s, args) =>
                {
                    lock (args)
                    {
                        PatientList = args.Result as IList<Patient>;
                    }
                })));

            //PatientList = DataAccessService.GetPatients(newSearchString, 50);
            //OnPropertyChanged("PatientList");


           /* tempPatient.GetPatients(newSearchString, (s, args) =>
            {
                lock (args)
                {
                    this.PatientList = args.Result as IList<Patient>;
                }
                OnPropertyChanged("PatientList");
            });*/
        }
    }
}
