using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows.Controls;
using System.Windows.Input;
using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.Ribbon.Schedule;

namespace ClinSchd.Modules.Ribbon.Tests.Mocks
{
    public class MockScheduleView : IScheduleView
    {
        public event EventHandler<EventArgs> ShowRibbon = delegate { };

        public SchedulePresentationModel Model { get; set; }
        
        public void RaiseShowRibbonEvent()
        {
            ShowRibbon(this, EventArgs.Empty);
        }

        #region IScheduleView Members


        public void FocusPatientSearch ()
        {
            
        }

        public void UpdatePatientSearchText( string patientName )
        {
            throw new NotImplementedException();
        }

        public void UpdateFutureAppointments( ObservableCollection<FuturePatientAppointment> futurePatientAppointments )
        {
            throw new NotImplementedException();
        }

        public void UpdatePatientFlags( Infrastructure.Models.Patient patient )
        {
            throw new NotImplementedException();
        }

        public void UpdateSpecialNeedsRibbon( List<string> preferences )
        {
            throw new NotImplementedException();
        }

        public bool ConfirmUser (string message, string caption)
        {
            return true;
        }

        public void AlertUser (string message, string caption)
        {
        }

        public void UpdateFutureAppointmentsOnly( Infrastructure.Models.Patient patient )
        {
            throw new NotImplementedException();
        }

        public void OpenNewRequestForPatient( Infrastructure.Models.Patient patient )
        {
            throw new NotImplementedException();
        }

        public void OpenNewRequestForPatient( Infrastructure.Models.Patient patient, DateTime desiredDateTime, string resourceIEN, string resourceName, string requestType = Keys.AppointmentRequestTypes.Appt )
        {
            throw new NotImplementedException();
        }

        public void UpdateSpecialNeedsFutureAppointmentsAndDemoInfo( Infrastructure.Models.Patient patient )
        {
            throw new NotImplementedException();
        }

        public void SetPatientSearchComboBoxOpen( bool openDropDown )
        {
            throw new NotImplementedException();
        }

        //public void UpdateTabOrder()
        //{
        //    throw new NotImplementedException();
        //}

        public void RibbonBarHotKeysHandler( Key k )
        {
            throw new NotImplementedException();
        }

        public void InjectVARButton( UserControl button )
        {
            throw new NotImplementedException();
        }

        public void SelectPatient( Infrastructure.Models.Patient patient, bool isVARRequest = false, string varPDDate = "" )
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
