using Microsoft.Practices.Composite.Events;
using Microsoft.Practices.Composite.Regions;
using ClinSchd.Infrastructure;
using ClinSchd.Modules.Ribbon.Schedule;

namespace ClinSchd.Modules.Ribbon.Controllers
{
    public class RibbonController : IRibbonController
    {
        private readonly IRegionManager _regionManager;
        private readonly ISchedulePresentationModel _schedulePresentationModel;
        private readonly IEventAggregator _eventAggregator;

        public RibbonController (IRegionManager regionManager, ISchedulePresentationModel schedulePresentationModel, IEventAggregator eventAggregator)
        {
            _regionManager = regionManager;
            _schedulePresentationModel = schedulePresentationModel;
            _eventAggregator = eventAggregator;
        }

        public void Run()
        {
            _regionManager.Regions[RegionNames.MainToolBarRegion].Add(_schedulePresentationModel.View);
            _regionManager.Regions[RegionNames.RequestQueueRegion].Add(_schedulePresentationModel.PatientQueueView);
        }
    }
}
