﻿using System.Windows;
using System.Windows.Input;
using ClinSchd.Infrastructure;

namespace ClinSchd.Modules.Ribbon.Schedule
{
    /// <summary>
    /// Interaction logic for AppointmentRequestTypeView.xaml
    /// </summary>
    public partial class AppointmentRequestTypeView
    {
        public bool IsDead { get; set; }
        public string AppointmentRequestType;
        public bool DialogResult { get; set; }
        public bool NoneChecked { get; set; }
        public AppointmentRequestTypeView()
        {
            InitializeComponent();
            BtnOk.Focus();
            Keyboard.Focus(BtnOk);
        }

        private void OK_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = true;
            if (RbApptType.IsChecked == true || RbPtCSchType.IsChecked == true)
                AppointmentRequestType = RbApptType.IsChecked == true ? Keys.AppointmentRequestTypes.Appt : Keys.AppointmentRequestTypes.PtCSch;
            else
                NoneChecked = true;

            var window = Window.GetWindow(this);
            if (window != null)
                window.Close();
        }

        private void Cancel_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
            var window = Window.GetWindow(this);
            if (window != null)
                window.Close();
        }

        private void AppointmentRequestType_Unloaded(object sender, RoutedEventArgs e)
        {
            Cancel_Click(sender, e);
        }

        private void ApptRequestType_Loaded(object sender, RoutedEventArgs e)
        {
            Keys.SetRenderingMode(this);
            if(IsDead)
            {
                RbApptType.IsChecked = false;
                RbApptType.IsEnabled = false;
                RbPtCSchType.IsChecked = false;
                RbPtCSchType.IsEnabled = false;
                //RbNone.IsChecked = true;
            }
        }

        private void HotKeyHandler(Key k)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                switch (k)
                {
                    case Key.O:
                        Keyboard.Focus(BtnOk);
                        break;
                    case Key.C:
                        Keyboard.Focus(BtnCancel);
                        break;
                }
            }

        }

        private void UserControl_PreviewKeyUp(object sender, KeyEventArgs e)
        {
            Key key = e.Key == Key.System ? e.SystemKey : e.Key;
            HotKeyHandler(key); 
        }
    }
}
