using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows.Controls;
using System.Windows.Input;
using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Ribbon.Schedule
{
    public interface IScheduleView
    {
        SchedulePresentationModel Model { get; set; }
        void FocusPatientSearch();
        void UpdatePatientSearchText(string patientName);
        void UpdateFutureAppointments(ObservableCollection<FuturePatientAppointment> futurePatientAppointments);
        void UpdatePatientFlags(Patient patient);
        void UpdateSpecialNeedsRibbon(List<string> preferences);
        bool ConfirmUser (string message, string caption);
        void AlertUser (string message, string caption);
        void UpdateFutureAppointmentsOnly(Patient patient);
        void OpenNewRequestForPatient(Patient patient);
        void OpenNewRequestForPatient(Patient patient, DateTime desiredDateTime, string resourceIEN, string resourceName, string requestType = Keys.AppointmentRequestTypes.Appt);
        void UpdateSpecialNeedsFutureAppointmentsAndDemoInfo(Patient patient);
        void SetPatientSearchComboBoxOpen(bool openDropDown);
//        void UpdateTabOrder();
        void RibbonBarHotKeysHandler(Key k);
        void PatientChanged(Patient patient, DateTime? desiredDateTime = null, string resourceIEN = "", string resourceName = "", string requestType = "", bool loadingFromSchedule = false);
        void ChangeViewMode(string viewMode);
        #region VARMobileRequest Members

        void InjectVARButton(UserControl button);

        void SelectPatient(Patient patient, bool isVARRequest = false, string varPDDate = "");

        #endregion VARMobileRequest Members
    }
}
