﻿using System.Collections.Generic;
using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Interfaces;
using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.DataAccess.Services;

namespace ClinSchd.Modules.Ribbon.ViewModels
{
    public class ClinicListViewModel : AsyncValidatableModel
    {
        public bool ConsultUrgencyActivated { get; set; }
        public bool IsPtCSchOnly { get; set; }
        private IDataAccessService _dataAccessService;
        public AppointmentRequest AppointmentRequest;

        private List<ClinicServiceList> _clinicServiceSelectionList;

        public List<ClinicServiceList> ClinicServiceSelectionList 
        { 
            get
            {
                if (_clinicServiceSelectionList == null)
                    _clinicServiceSelectionList = new List<ClinicServiceList>();

                /*foreach (ClinicServiceList item in _clinicServiceSelectionList)
                    {
                        _serviceSelectionList.Add(new ClinicServiceList
                        {
                            Name = svc.Name,
                            Ien = svc.Ien,
                            IsSelected = false
                        });
                    }*/
                    //OnPropertyChanged("ClinicServiceSelectionList");
                
                return _clinicServiceSelectionList;
            }
            set
            {
                _clinicServiceSelectionList = value;
                NotifyPropertyChanged("ClinicServiceSelectionList");
            }
        }

        public bool IsServiceList { get; set; }

        public IList<Clinic> ClinicSelectionList(string searchText)
        {
            return _dataAccessService.SearchPtCSchClinics(searchText);
        }

        public IList<ServiceSpecialty> ServiceSpecialties( string searchString )
        {
            return AppointmentRequest.GetApptServiceSpecialties( searchString );
        }

        public ClinicListViewModel(IDataAccessService dataAccessService)
        {
            _dataAccessService = dataAccessService;
            AppointmentRequest = new AppointmentRequest(_dataAccessService);
        }

        public bool IsSelected { get; set; }
    }
}
