﻿using System;
using System.Windows.Controls;
using System.Windows.Input;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Ribbon.ViewModels
{
    public class DatesLogicVM : BaseViewModel
    {
        const string DLIM = ",";

        private ComboBoxItem _ciAndOr;
        private ComboBoxItem _ciCondition1;
        private ComboBoxItem _ciCondition2;
        private DateTime? _date2;
        private DateTime? _date1;
        private bool _hasDate1;

        public Action<string> CloseCallback { get; set; }

        public DateTime? Date1
        {
            get { return _date1; }
            set
            {
                _date1 = value;
                HasDate1 = _date1 != null;
                NotifyPropertyChanged("Date1");
            }
        }

        public string Condition1 { get; set; }

        public ComboBoxItem CiCondition1
        {
            get { return _ciCondition1; }
            set
            {
                _ciCondition1 = value;
                Condition1 = (string)value.Tag;
            }
        }

        public bool HasDate1
        {
            get { return _hasDate1; }
            set
            {
                _hasDate1 = value;
                NotifyPropertyChanged( "HasDate1" );
            }
        }

        //public bool MatchCase1 { get; set; }
        public string AndOr { get; set; }

        public ComboBoxItem CiAndOr
        {
            get { return _ciAndOr; }
            set
            {
                _ciAndOr = value;
                AndOr = (string)value.Tag;
            }
        }

        public DateTime? Date2
        {
            get { return _date2; }
            set { _date2 = value; }
        }

        public string Condition2 { get; set; }

        public ComboBoxItem CiCondition2
        {
            get { return _ciCondition2; }
            set
            {
                _ciCondition2 = value;
                Condition2 = (string)value.Tag;
            }
        }

        //public bool MatchCase2 { get; set; }

        #region ICloseCommandProvider Members

        public bool IsClosing { get; private set; }

        public ICommand CloseCommand
        {
            get
            {
                return GetCommand(
                    "CloseCommand",
                    _ =>
                    {
                        IsClosing = true;
                        if ( CloseCallback != null )
                        {
                            CloseCallback( null );
                        }
                    },
                    _ => true
                    );
            }
        }

        #endregion ICloseCommandProvider Members

        #region ISaveCommandProvider Members

        public ICommand SaveCommand
        {
            get
            {
                return GetCommand(
                    "SaveCommand",
                    _ =>
                    {
                        if ( CloseCallback != null )
                        {
                            // Build the logic string 
                            var dateFilter = Condition1 + DLIM + Date1?.ToShortDateString() + DLIM +  
                                             AndOr + DLIM + 
                                             Condition2 + DLIM + Date2?.ToShortDateString();
                            CloseCallback( dateFilter );
                        }
                    },
                    _ => Date1 != null || Date2 != null );
            }
        }

        #endregion ISaveCommandProvider Members
    }
}
