﻿using System.Collections.Generic;
using System.ComponentModel;
using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Ribbon.ViewModels
{
    public class RequestTypeListViewModel : INotifyPropertyChanged
    {
        public bool ConsultUrgencyActivated { get; set; }
        private IList<RequestType> _requestSelectionList;
        public IList<RequestType> RequestSelectionList
        {
            get
            {
                if (_requestSelectionList == null)
                {
                    _requestSelectionList = new List<RequestType>();
                    var apptType = new RequestType
                        {
                            IsSelected = false,
                            RequestName = "APPOINTMENT" //not APPT for some reason...
                        };
                    if(!ConsultUrgencyActivated)
                        _requestSelectionList.Add(apptType);
                    
                    var consultType = new RequestType
                    {
                        IsSelected = false,
                        RequestName = Keys.AppointmentRequestTypes.Consult
                    };
                    _requestSelectionList.Add(consultType);

                    var ewlType = new RequestType
                    {
                        IsSelected = false,
                        RequestName = Keys.AppointmentRequestTypes.Ewl
                    };
                    if(!ConsultUrgencyActivated)
                        _requestSelectionList.Add(ewlType);

                    var ptCSchType = new RequestType
                    {
                        IsSelected = false,
                        RequestName = Keys.AppointmentRequestTypes.PtCSch
                    };
                    if(!ConsultUrgencyActivated)
                        _requestSelectionList.Add(ptCSchType);

                    OnPropertyChanged("RequestSelectionList");
                }
                return _requestSelectionList;
            }
            set 
            { 
                _requestSelectionList = value;
                OnPropertyChanged("RequestSelectionList");
            }
        }

        public bool IsSelected { get; set; }
        public event PropertyChangedEventHandler PropertyChanged;
        public virtual void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if ( handler != null )
                handler( this, args );
        }
        public void OnPropertyChanged(string propertyName)
        {
            OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }
}
