﻿using System;
using System.Windows.Input;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Ribbon.ViewModels
{
    public class WaitTimeVM : BaseViewModel
    {
        public Action<string> CloseCallback { get; set; }

        #region ICloseCommandProvider Members

        public bool IsClosing { get; private set; }

        public ICommand CloseCommand
        {
            get
            {
                return GetCommand(
                    "CloseCommand",
                    _ =>
                    {
                        IsClosing = true;
                        if ( CloseCallback != null )
                        {
                            CloseCallback( null );
                        }
                    },
                    _ => true
                    );
            }
        }

        #endregion ICloseCommandProvider Members

        #region ISaveCommandProvider Members

        public ICommand SaveCommand
        {
            get
            {
                return GetCommand(
                    "SaveCommand",
                    parm =>
                    {
                        if ( CloseCallback != null )
                        {
                            CloseCallback( parm.ToString() );
                        }
                    },
                    _ => true );
            }
        }

        #endregion ISaveCommandProvider Members
    }
}
