﻿using System.Linq;
using System.Windows.Controls;
using System.Windows.Input;
using ClinSchd.Modules.Ribbon.ViewModels;
using WPF.JoshSmith.ServiceProviders.UI;

namespace ClinSchd.Modules.Ribbon.Views
{
    /// <summary>
    /// Interaction logic for UserPreferencesV.xaml
    /// </summary>
    public partial class UserPreferencesV
    {
        private UserPreferencesVM _vm;

        private UserPreferencesVM VM
        {
            get { return _vm ?? ( _vm = (UserPreferencesVM)DataContext ); }
        }

        public UserPreferencesV()
        {
            InitializeComponent();
            DataContext = this;
        }

        private void BaseDialogView_Loaded( object sender, System.Windows.RoutedEventArgs e )
        {
            new ListViewDragDropManager<ColumnSetting>( Columns );  // Special line for handling drag and drop.  Only line required to implement Drag and Drop.  Josh Smith
        }

        private void ComboBox_SelectionChanged( object sender, SelectionChangedEventArgs e )
        {
            var cb = (ComboBox)sender;
            var rs = (ColumnSetting)cb.DataContext;
            // Check Sort Order
            foreach ( var userSetting in VM.ColumnSettings.Where( us => us.SortOrder == rs.SortOrder && us.Name != rs.Name ) )
            {
                userSetting.SortOrder = "";
            }
        }

        private void HotKeyHandler(object sender, KeyEventArgs e)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                Key key = e.Key == Key.System ? e.SystemKey : e.Key;
                switch (key)
                {
                    case Key.O:
                        Keyboard.Focus(OkButton);
                        break;
                    case Key.L:
                        Keyboard.Focus(ClearButton);
                        break;
                    case Key.C:
                        Keyboard.Focus(CancelButton);
                        break;
                }
            }
        }
    }
}
