//===================================================================================
// Microsoft patterns & practices
// Composite Application Guidance for Windows Presentation Foundation and Silverlight
//===================================================================================
// Copyright (c) Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===================================================================================
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
//===================================================================================
using ADT.Infrastructure.Models;
using ADT.Modules.Task.Group;

namespace ADT.Modules.Task.Tests.Mocks
{
    internal class MockTaskReaderView : ITaskReaderView
    {
        public bool ShowViewWasCalled { get; private set; }

        private TaskGroup model;

        public void ShowView()
        {
            this.ShowViewWasCalled = true;
        }

        public TaskGroup Model
        {
            get { return this.model; }
            set { this.model = value; }
        }

		public void SetTaskGroup(TaskGroup group)
        {
			this.Model = group;
        }
    }
}