using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Animation;
using Telerik.Windows.Controls;

using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Task.AddEditAvailability
{
    /// <summary>
	/// Interaction logic for AddResourceView.xaml
    /// </summary>
	public partial class AddEditAvailabilityView : Window, IAddEditAvailabilityView
    {
		public AddEditAvailabilityView ()
        {
            InitializeComponent();
        }

		public AddEditAvailabilityPresentationModel Model
        {
            get
            {
				return this.DataContext as AddEditAvailabilityPresentationModel;
            }

            set
            {
                this.DataContext = value;
            }
        }

		protected override void OnClosing (System.ComponentModel.CancelEventArgs e)
		{
			this.Visibility = Visibility.Hidden;
			e.Cancel = true;
		}

		private void CancelButton_Click (object sender, RoutedEventArgs e)
		{
			Close ();
		}

		private void OkButton_Click (object sender, RoutedEventArgs e)
		{
			this.Model.ExecuteAddEditAvailabilityCommand (string.Empty);
			if (this.Model.ValidationMessage.IsValid) {
				Close ();
			} else {
				this.Model.View.AlertUser (this.Model.ValidationMessage.Message, this.Model.ValidationMessage.Title);
			}
		}

		private bool bDialogResult = false;
		public bool ConfirmUser (string message, string caption)
		{
            bDialogResult = Infrastructure.Keys.ConfirmUser(this, message, caption);
            return bDialogResult;
        }   

		public void AlertUser (string message, string caption)
		{
            Infrastructure.Keys.AlertUser(this, message, caption);
        }

		private void AccessGroup_SelectionChanged (object sender, SelectionChangedEventArgs e)
		{
			this.Model.LoadGroupedAccessTypes ();
		}

	}
}
