using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Animation;
using System.Collections.Generic;

using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;
using System.Collections;
using System.Collections.ObjectModel;
using ClinSchd.Infrastructure;
using System.Linq;
using System.Net;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Calendar;
using ClinSchd.Modules.Task.Group;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Task.Availability
{
    /// <summary>
	/// Interaction logic for AvailabilityView.xaml
    /// </summary>
	public partial class AvailabilityView : RadPane, IAvailabilityView, ITaskView
    {
		public AvailabilityPresentationModel AvailabilityViewModel
		{
			get { return this.Model as AvailabilityPresentationModel; }
			set { this.Model = value; }
		}

		public AvailabilityView (IAvailabilityPresentationModel availabilityViewModel)
		{
            AvailabilityViewModel = (AvailabilityPresentationModel)availabilityViewModel;
            AvailabilityViewModel.View = this;
            InitializeComponent();
        }

        public ITaskPresentationModel Model
        {
            get { return this.DataContext as AvailabilityPresentationModel; }
            set { this.DataContext = value; }
        }

		public RadScheduleView Scheduler
		{
			get
			{
				return this.scheduler;
			}
		}

		public void Collapse()
		{
			IsHidden = true;
		}

		public void Expand()
		{
			IsHidden = false;
		}

		private void scheduler_AppointmentCreating (object sender, AppointmentCreatingEventArgs e)
		{
			//turn off the default adding appointment dialog window.
			e.Cancel = true;
		}

		private void scheduler_AppointmentEditing (object sender, AppointmentEditingEventArgs e)
		{
            e.Cancel = true;
        }

        private void scheduler_AppointmentDeleting (object sender, AppointmentDeletingEventArgs e)
		{
			e.Cancel = true;
		}
		
        public void ScrollSchedulerToOffset()
        {
            try
            {
                Scheduler.ScrollTimeRuler(TimeSpan.FromHours(AvailabilityViewModel.FirstVisibleHour), true);
            }
            catch (Exception ex)
            {
                TraceLog.LogException(GetType().Name, "ScrollSchedulerToOffset", ex);
            }
        }

		private bool bDialogResult = false;
		public bool ConfirmUser (string message, string caption)
		{
            bDialogResult = Infrastructure.Keys.ConfirmUser(this, message, caption);
            return bDialogResult;
        }   

		public void AlertUser (string message, string caption)
		{
            Infrastructure.Keys.AlertUser(this, message, caption);
        }

		//Default the time slot to be 8AM
		private void paneTaskAvailability_Unloaded (object sender, RoutedEventArgs e)
		{
			Model.ClearViewFromList ();
		}

        private void paneTaskScheduler_Loaded(object sender, EventArgs e) { }

		public void Close ()
		{
			RemoveFromParent ();
		}

        private void scheduler_ShowDialog(object sender, ShowDialogEventArgs e)
        {
            e.Cancel = true;
        }
    }
}
