using System;
using System.Collections.Generic;
using System.ComponentModel;

using Microsoft.Practices.Composite.Presentation.Commands;

using Telerik.Windows.Controls;

using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.Task.Availability.Controllers;

namespace ClinSchd.Modules.Task.Availability
{
    public interface IAvailabilityPresentationModel
    {
        IAvailabilityView View { get; set; }
        string ScheduleID { get; set; }
        void RefreshAvailabilityScheduler(string command);
        int FirstVisibleHour { get; }

        //Patient Patient { get; set; }
        string PaneTitle { get; set; }
        string ResourceName { get; set; }
        int DayRange { get; set; }
        System.TimeSpan TimeScale { get; set; }
        bool IsSelectedTab { get; set; }
        SchdResource SelectedResource { get; set; }
        DateTime VisibleStartDate { get; set; }
        DateTime VisibleEndDate { get; set; }
        int TimeSlotToSkip { get; set; }
        ITaskAvailabilityController Controller { get; set; }
        IList<SchdAvailability> AvailabilityList { get; set; }
        SchdAvailability SchdAvailability { get; set; }
        IList<ResourceType> ResourceTypesCollection { get; }
        IList<GroupDescription> GroupsDescriptionCollection { get; }
    }
}
