using System;
using System.Windows;
using Telerik.Windows.Controls;
using ClinSchd.Modules.Task.Group;
using ClinSchd.Modules.Task.ChildModules.MultiScheduler;

namespace ClinSchd.Modules.Task.MultiScheduler
{
    /// <summary>
    /// Interaction logic for GroupView.xaml
    /// </summary>
    public partial class MultiSchedulerView : RadPane, IMultiSchedulerView, ITaskView, IGroupView, IDisposable
    {
        public MultiSchedulerView()
        {
            InitializeComponent();
        }

        public MultiSchedulerPresentationModel Model
        {
            get { return DataContext as MultiSchedulerPresentationModel; }
            set { DataContext = value; }
        }

        public event EventHandler<EventArgs> ShowTask;

        private void TasksDocking_Close(object sender, Telerik.Windows.Controls.Docking.StateChangeEventArgs e)
        {
            
        }

        public void DockSchedule(RadPane schedule)
        {
            MultiScheduleDock.Items.Add(schedule);
        }

        #region ITaskView Members

        ITaskPresentationModel ITaskView.Model
        {
            get { return DataContext as MultiSchedulerPresentationModel; }
            set { DataContext = value; }
        }

        public RadSplitContainer MultiSchedulerGroupControl
        {
            get { return MultiSchedulerGroup; }
        }

        #endregion

        #region IGroupView Members

        GroupPresentationModel IGroupView.Model
        {
            get
            {
                throw new NotImplementedException ();
            }
            set
            {
                throw new NotImplementedException ();
            }
        }

        public void FocusSchedulerGroup ()
        {

        }

        #endregion

        private void RadPane_Unloaded (object sender, RoutedEventArgs e)
        {            
//			Model.ClearViewFromList ();
        }

        #region IDisposable members
    
        protected void Dispose(bool itIsSafeToAlsoFreeManagedObjects)
        {
            try
            {
                // Free unmanaged resources

                //Free managed resources too, but only if I'm being called from Dispose
                //(If I'm being called from Finalize then the objects might not exist
                //anymore
                if (itIsSafeToAlsoFreeManagedObjects)
                {
                    Model.IsSelectedTab = false;

                    if (Model != null)
                    {
                        Model.Dispose();
                        Model = null;
                    }

                    MultiSchedulerDocking.Close -= TasksDocking_Close;

                    for (int idx = MultiScheduleDock.Items.Count - 1; idx >= 0; idx-- )
                    {
                        ClinicGroupMultiView child = (ClinicGroupMultiView)MultiScheduleDock.Items[idx];
                        child.RespondToEvents(false);
                        child.RemoveFromParent();
                        //child.Dispose();
                    }

                    Unloaded -= RadPane_Unloaded;
                    Content = null;
                    Header = null;
                    ContextMenu = null;
                    DataContext = null;
                }
            }
            catch (Exception ex)
            {
                Infrastructure.TraceLog.LogException(GetType().Name, "Dispose", ex);
                //MessageBox.Show(ex.Source + ": " + ex.Message);
            }
        }
    
        public void Dispose()
        {
            Dispose(true); //true: safe to free managed resources
            GC.SuppressFinalize(this); //Hey, GC: don't bother calling finalize later
        }

        ~MultiSchedulerView()
        {
            //we're being finalized (i.e. destroyed), call Dispose in case the user forgot to
            Dispose(false);
        }
    
        #endregion IDisposable members

    }
}
