using System;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.ComponentModel;
using ClinSchd.Infrastructure.Models;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;
using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Interfaces;
using ClinSchd.Modules.Task.Scheduler.Controllers;

namespace ClinSchd.Modules.Task.Scheduler
{
    public interface ISchedulerPresentationModel
    {
        string ScheduleID { get; set; }
        IDataAccessService DataAccessService { get; }
        void OnPropertyChanged(string propertyName);
        ISchedulerView View { get; set; }
        void RefreshAppoinmentScheduler(string command);
        string PaneTitle { get; set; }
        string ResourceName { get; }
        int DayRange { get; set; }
        TimeSpan TimeScale { get; set; }
        bool IsEnableUpdateAppointment { get; set; }
        bool IsSelectedTab { get; set; }
        SchdResource SelectedResource { get; set; }
        SchdResourceGroup SelectedResourceGroup { get; set; }
        IList<GroupDescription> GroupsDescriptionCollection { get; }
        IList<ResourceType> ResourceTypesCollection { get; }
        IList<SchdAppointment> AppointmentList { get; set; }
        Factory<SchdAppointment> SchdAppointmentFactory { get; set; }
        DateTime CurrentSelectedDate { get; set; }
        DateTime VisibleStartDate { get; set; }
        DateTime VisibleEndDate { get; set; }
        Dictionary<string, Category> AppointmentCategories { get; }
        SchdAppointment SchdAppointment { get; set; }
        ITaskSchedulerController Controller { get; set; }
        void ViewModeChanged (string mode);
        void PatientSelected (Patient selectedPatient);
        void RespondToEvents(bool respond);
        bool IsInitialized { get; }
        DateTime LastUpdate { get; }
        DateTime? MultiCalendarDayViewDate { get; set; }
        ViewModes ViewMode { get; }
        DateTime ActiveMonthStartDate { get; }
        bool ProhibitedClinic { get; }
        bool PrivilegedUser { get; } 
        Slot SelectedTimeSlot { get; set; }
        Appointment SelectedAppointment { get; set; }
        IAppointment SelectedTimeSlotViewerAppointment { get; set; }
        AppointmentRequest CurrentAppointmentRequest { get; set; }
        FuturePatientAppointment CurrentPendingAppointment { get; set; }
        bool IsPartofGoupSchedule { get; set; }
        Patient SelectedPatient { get; set; }
        ObservableCollection<CustomSlot> SlotsCollection { get; }
        bool DayOfSelectedTimeSlotHasAvailability { get; }
        bool IsSlotContextMenuVisible { get; }
        bool IsContextMenuOpen { get; set; }
        int FirstVisibleHour { get; }
        void SchedulerDateChanged(SchedulerViewDateEventArgs newDate);
        bool MoveAppointment(CustomAppointment originalAppointment, SchdResource originalResource, Slot targetSlot, SchdResource targetClinic);
        void ResizeAppointment(Appointment newAppointment, int duration, bool isVariableLengthClinic);
        void Dispose();
    }
}
