﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;

using Telerik.Windows.Controls;

using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Task.Scheduler
{
    internal class VSEAppointmentStyleSelector : OrientedAppointmentItemStyleSelector
    {
        public Style AllDayEventHorizontalStyle { get; set; }
        public Style AllDayEventVerticalStyle { get; set; }
        public Style AppointmentHorizontalStyle { get; set; }
        public Style AppointmentVerticalStyle { get; set; }
        public Style AppointmentMonthStyle { get; set; }
        public Style AllDayEventMonthStyle { get; set; }
        public Style AppointmentTimeLineStyle { get; set; }

        public override Style SelectStyle(object item, DependencyObject container, ViewDefinitionBase activeViewDefinition)
        {
            try
            {
                //AppointmentItem apptItem = (AppointmentItem)container;
                //AppointmentsPanel apptPanel = (AppointmentsPanel)apptItem.Parent;

                //if (apptPanel != null)
                //{
                //    Grid apptPanelGrid = (Grid)apptPanel.Parent;



                //    if (activeViewDefinition is TimelineViewDefinition)
                //    {
                //        apptPanel.VerticalAlignment = VerticalAlignment.Top;
                //        apptPanel.HorizontalAlignment = HorizontalAlignment.Stretch;
                //    }
                //    else
                //    {
                //        apptPanel.VerticalAlignment = VerticalAlignment.Stretch;
                //        apptPanel.HorizontalAlignment = HorizontalAlignment.Left;
                //    }
                //}

                CustomAppointment appointment = item as CustomAppointment;

                if (activeViewDefinition is TimelineViewDefinition)
                {
                    if (appointment.IsAllDayEvent)
                        return AllDayEventMonthStyle;

                    return AppointmentTimeLineStyle;
                }

                if (appointment != null)
                {
                    if (activeViewDefinition is VSEMonthViewDefninition)
                    {
                        if (appointment.IsAllDayEvent)
                            return AllDayEventMonthStyle;

                        return AppointmentMonthStyle;
                    }
                    else
                    {
                        if (activeViewDefinition.GetOrientation() == Orientation.Horizontal)
                        {
                            if (appointment.IsAllDayEvent)
                                return AllDayEventHorizontalStyle;

                            return AppointmentHorizontalStyle;
                        }
                        else
                        {
                            if (appointment.IsAllDayEvent)
                                return AllDayEventVerticalStyle;

                            return AppointmentVerticalStyle;
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                TraceLog.LogException(this.GetType().Name, "SelectStyle", ex);
            }

            return base.SelectStyle(item, container, activeViewDefinition);
        }
    }
}
