﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

using Telerik.Windows.Controls;

using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Task.Scheduler
{
    internal class VSEAppointmentTemplateSelector : ScheduleViewDataTemplateSelector
    {
        public DataTemplate AppointmentTemplate { get; set; }
        public DataTemplate AllDayEventTemplate { get; set; }
        public DataTemplate TimeLineViewTemplate { get; set; }

        public override DataTemplate SelectTemplate(object item, DependencyObject container, Telerik.Windows.Controls.ViewDefinitionBase activeViewDefinition)
        {
            try
            { 
                AppointmentItem presenter = (AppointmentItem)container;
                
                if (presenter != null)
                {
                    CustomAppointment custAppt = (CustomAppointment)presenter.Appointment;

                    if (presenter.IsAllDay)
                    {
                        if (custAppt.ToolTipEnabled)
                            presenter.ToolTip = custAppt.ToolTipText;
                        else
                            presenter.ToolTipOpening += presenter_ToolTipOpening;
                    }
                }

                if (activeViewDefinition is TimelineViewDefinition)
                    return TimeLineViewTemplate;

                return AppointmentTemplate;
            }
            catch (Exception ex)
            {
                TraceLog.LogException(this.GetType().Name, "SelectTemplate", ex);
            }

            return AppointmentTemplate;
        }

        private void presenter_ToolTipOpening(object sender, ToolTipEventArgs e)
        {
            e.Handled = true;
        }

    }
}
