﻿using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;

namespace ClinSchd.Modules.Task.Scheduler
{
    internal class VSEDayViewDefinition : DayViewDefinition
    {
        private int _timeScale;

        public int TimeScale
        {
            get { return _timeScale; }
            set
            {
                if (_timeScale != value)
                {
                    _timeScale = value;
                    int timeScaleIndex = 60 / _timeScale;
                    MinorTickLength = new FixedTickProvider(new DateTimeInterval(timeScaleIndex < 3 ? 15 : _timeScale, 0, 0, 0, 0));
                    MinTimeRulerExtent = 17 * 24 * (timeScaleIndex < 3 ? 4 : timeScaleIndex);
                    OnPropertyChanged("MinorTickLength");
                    OnPropertyChanged("MinTimeRulerExtent");
                }
            }
        }

        public VSEDayViewDefinition()
        {
            GroupHeaderDateStringFormat = "{0:dd dddd}";
            ShowAllDayArea = true;
            TimerulerMinorTickStringFormat = "{0: :mm}";
            MajorTickLength = new FixedTickProvider(new DateTimeInterval(0, 1, 0, 0, 0));
            base.MaxTimeRulerExtent = 10000;
        }
    }
}
