﻿using System;
using System.Windows;
using System.Windows.Controls;

using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;

using ClinSchd.Infrastructure;
using ClinSchd.Infrastructure.Models;

namespace ClinSchd.Modules.Task.Scheduler
{
    internal class VSESpecialtySlotSelector : ScheduleViewStyleSelector
    {
        #region public properties

        public Style AllDaySlotStyle { get; set; }

        public Style NonMenuedSlotStlye { get; set; }

        public Style MenuedSlotStlye { get; set; }

        public Style TimelineSlotStlye { get; set; }

        #endregion public properties

        #region overidden members

        public override Style SelectStyle(object item, DependencyObject container, ViewDefinitionBase activeViewDefinition)
        {

            CustomSlot slot = item as CustomSlot;

            if (slot.SlotCategory.CategoryName == Keys.SlotCategoryNames.AllDaySlot)
                return NonMenuedSlotStlye;

            if (slot.SlotCategory.CategoryName == Keys.SlotCategoryNames.NonWorkingSlot)
                return NonMenuedSlotStlye;

            if (slot.SlotCategory.CategoryName == Keys.SlotCategoryNames.UnavailableSlot)
            {
                if (activeViewDefinition is TimelineViewDefinition)
                    return TimelineSlotStlye;

                return MenuedSlotStlye;
            }

            if (slot.SlotCategory.CategoryName == Keys.SlotCategoryNames.AvailableSlot)
            {
                if (activeViewDefinition is TimelineViewDefinition)
                    return TimelineSlotStlye;

                return MenuedSlotStlye;
            }

            if (slot.SlotCategory.CategoryName == Keys.SlotCategoryNames.CancelledAvailabilitySlot)
                return NonMenuedSlotStlye;

            if (slot.SlotCategory.CategoryName == Keys.SlotCategoryNames.HolidayNotWorkingSlot)
                return NonMenuedSlotStlye;

            if (slot.SlotCategory.CategoryName == Keys.SlotCategoryNames.HolidayUnavailableSlot)
                return MenuedSlotStlye;

            if (slot.SlotCategory.CategoryName == Keys.SlotCategoryNames.HolidayAvailableSlot)
                return MenuedSlotStlye;

            if (slot.SlotCategory.CategoryName == Keys.SlotCategoryNames.HolidayCancelledAvailabilitySlot)
                return NonMenuedSlotStlye;

            return NonMenuedSlotStlye;
        }

        #endregion overidden members
    }
}
