using System;
using System.Windows;
using Telerik.Windows.Controls;
using System.Windows.Input;

namespace ClinSchd.Modules.Task.Group
{
    /// <summary>
    /// Interaction logic for GroupView.xaml
    /// </summary>
    public partial class GroupView : RadPane, IGroupView
    {
        public GroupView()
        {
            InitializeComponent();
        }

        public GroupPresentationModel Model
        {
            get { return DataContext as GroupPresentationModel; }
            set { DataContext = value; }
        }

        private void TasksDocking_Close(object sender, Telerik.Windows.Controls.Docking.StateChangeEventArgs e)
        {
        }

        private void RadPaneGroup_SelectionChanged( object sender, RoutedEventArgs e )
        {
            for ( var i = 0; i < SchedulerGroup.Items.Count; i++ )
            {
                if ( SchedulerGroup[i].IsSelected )
                {
                    var selectedTab = (RadPane)SchedulerGroup.Items[i];
                    var selectedModel = ( (ITaskView)selectedTab ).Model;
                    selectedModel.IsSelectedTab = true;
                    if ( selectedModel.SelectedResource != null )
                    {
                        selectedModel.TaskTabSelectedCommand.Execute( selectedModel.SelectedResource );
                    }
                    else if ( selectedModel.SelectedResourceGroup != null )
                    {
                        selectedModel.TaskTabSelectedCommand.Execute( selectedModel.SelectedResourceGroup );
                    }
                    if ( selectedModel is Availability.AvailabilityPresentationModel )
                    {
                        Model.HideLegend();
                    }
                    else
                    {
                        Model.ShowLegend();
                    }
                }
                else
                {
                    var unSelectedTab = (RadPane)SchedulerGroup.Items[i];
                    var unSelectedModel = ( (ITaskView)unSelectedTab ).Model;
                    unSelectedModel.IsSelectedTab = false;
                }
            }
        }

        public void FocusSchedulerGroup ()
        {
            try
            {
                if (SchedulerGroup != null && SchedulerGroup.SelectedPane != null)
                    Keyboard.Focus(SchedulerGroup.SelectedPane);
            }
            catch (Exception ex)
            {
                Infrastructure.TraceLog.LogInfo("Modules.Task.Group.GroupView", "Exception",
                                                "Source: " + ex.Source + "  Message: " + ex.Message + "Target: " +
                                                ex.TargetSite);
            }
        }
    }
}
