using System.Windows;
using System.Windows.Input;
using ClinSchd.Infrastructure;

namespace ClinSchd.Modules.UserLogin.UserLogin
{
    /// <summary>
    /// Interaction logic for UserLoginView.xaml
    /// </summary>
    public partial class UserLoginView : Window, IUserLoginView
    {
        public UserLoginView ()
        {
            InitializeComponent();
            TxtVersion.Text = Keys.ApplicationVersion;
#if DEBUG
            AccessCode.Password = "PRMQ640";
            VerifyCode.Password = "6752DRJ#";
#endif
        }

        public UserLoginPresentationModel Model
        {
            get { return DataContext as UserLoginPresentationModel; }
            set { DataContext = value; }
        }

        private void Button_OK_Click(object sender, RoutedEventArgs e)
        {
            Model.AccessCode = AccessCode.Password;
            Model.VerifyCode = VerifyCode.Password;
            
            Model.ExecuteUserLoginCommand ("User Login");
            if (Model.ValidationMessage.IsValid) {
                Close ();
            } else {
                Model.View.AlertUser (Model.ValidationMessage.Message, Model.ValidationMessage.Title);
                AccessCode.Clear();
                VerifyCode.Clear();
            }
        }

        private void Button_Cancel_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private bool _bDialogResult;
        public bool ConfirmUser (string message, string caption)
        {
            _bDialogResult = Keys.ConfirmUser(this, message, caption);
            return _bDialogResult;
        }

        public void AlertUser (string message, string caption)
        {
            Keys.AlertUser(this, message, caption);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Keys.SetRenderingMode(this);
            Keyboard.Focus(AccessCode);
        }

        private void HotkeyHandler(Key k)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                switch (k)
                {
                    case Key.O:
                        Keyboard.Focus(BtnOk);
                        break;
                    case Key.C:
                        Keyboard.Focus(BtnCancel);
                        break;
                }
            }
        }

        private void UserControl_PreviewKeyUp(object sender, KeyEventArgs e)
        {
            Key key = (e.Key == Key.System ? e.SystemKey : e.Key);
            HotkeyHandler(key);
        }

        private void Window_Deactivated(object sender, System.EventArgs e)
        {
            //Activate();
        }
    }
}
