using Microsoft.Practices.Composite.Modularity;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Composite.Events;
using ClinSchd.Modules.UserLogin.UserLogin;
using ClinSchd.Modules.UserLogin.Controllers;
using ClinSchd.Modules.UserLogin.Services;

namespace ClinSchd.Modules.UserLogin
{
    public class UserLoginModule : IModule
    {
        private readonly IUnityContainer _container;
        private readonly IEventAggregator _eventAggregator;
        private IUserLoginController _controller;

        public UserLoginModule (IUnityContainer container, IEventAggregator eventAggregator)
        {
            this._container = container;
            this._eventAggregator = eventAggregator;
        }

        public void Initialize()
        {
            RegisterViewsAndServices ();
            _controller = _container.Resolve<IUserLoginController> ();
            _controller.Run ();
        }

        protected void RegisterViewsAndServices()
        {
            _container.RegisterType<IUserLoginController, UserLoginController> ();
            _container.RegisterType<IUserLoginView, UserLoginView> ();
            _container.RegisterType<IUserLoginPresentationModel, UserLoginPresentationModel> ();
            _container.RegisterType<IUserLoginService, UserLoginService> ();
        }
    }
}
