﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

using Microsoft.Practices.Composite.Presentation.Commands;

using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.VAR.Controllers;
using ClinSchd.Modules.VAR.Models;

namespace ClinSchd.Modules.VAR.ProcessRequest
{
    public enum ProcessTypes
    {
        Booked,
        NotBooked
    }

    public interface IProcessRequestPresentationModel
    {
		IProcessRequestView View { get; }
		ValidationMessage ValidationMessage { get; set; }

        DelegateCommand<string> CloseCommand { get; }
        DelegateCommand<string> SaveCommand { get; }

        IProcessRequestModel ProcessRequestModel { get; set; }

        string ProcessTitle { get; }
        Visibility AppointmentBarVisibility { get; }
        string StatusText { get; }
	    Visibility BookedAppointmentVisibility { get; }
	    string FormattedAppointmentTime { get; }
	    Visibility PickAppointmentVisibility { get; }
	    DateTime? AppointmentDateTime { get; set; }
        string ResourceName { get; }
        IList<SchdResource> ResourceList { get; }
        SchdResource SelectedResource { get; set; }
        string MessageToSend { get; set; }

        void OnClose ();

        void ResourceSearchStringChanged(string newSearchString);
        void ResourceScrollChanged(System.Windows.Controls.ScrollViewer scrollViewer);
    }
}
