﻿using System;
using System.ComponentModel;

using Microsoft.Practices.Composite.Presentation.Commands;

using ClinSchd.Infrastructure.Models;
using VSE_VAR_Service;

namespace ClinSchd.Modules.VAR.VAR
{
    public interface IAppointmentRequestItemPresentationModel
    {
        DelegateCommand<string> CloseCommand { get; }
        DelegateCommand<string> RequestApprovedCommand { get; }
        DelegateCommand<string> RequestNotAvailableCommand { get; }

        APPOINTMENT_REQUEST Request { get; set; }
        string APPOINTMENT_REQUEST_ID { get; }
        string APPOINTMENT_TYPE { get; }
        System.Collections.Generic.IList<string> BEST_TIME { get; }
        string BestTimesFormatted { get; }
        DateTime CREATED_DATE { get; }
        string CREATED_DATEFormatted { get; }
        string CREATED_DATEShortStringSortable { get; }
        DateTime DOB { get; }
        string DOBFormatted { get; }
        string DOBShortStringSortable { get; }
        string FACILITY_CODE { get; }
        string FACILITY_NAME { get; }
        string FIRST_NAME { get; }
        string LAST_NAME { get; }
        string LastMessage { get; }
        string LockedByUser { get; }
        string MessageToVeteran { get; set; }
        APPOINTMENT_REQUEST_LIST_ITEM Model { get; }
        string Option_1_DateTime { get; }
        string Option_1_DateTimeSortable { get; }
        string Option_2_DateTime { get; }
        string Option_2_DateTimeSortable { get; }
        string Option_3_DateTime { get; }
        string Option_3_DateTimeSortable { get; }
        string OPTION_DATE_1 { get; }
        string OPTION_DATE_2 { get; }
        string OPTION_DATE_3 { get; }
        string OPTION_TIME_1 { get; }
        string OPTION_TIME_2 { get; }
        string OPTION_TIME_3 { get; }
        string OTHER_PURPOSE_OF_VISIT { get; }
        string PatientName { get; }
        string PHONE_NUMBER { get; }
        string PROVIDER_ID { get; }
        string PROVIDER_NAME { get; }
        string ProviderFormatted { get; }
        string PURPOSE_OF_VISIT { get; }
        string PurposeOfVisitFormatted { get; }
        bool REQUESTED_PHONE_CALL { get; }
        string SSN { get; }
        string Title { get; }
        IVARDetailView View { get; set; }
        string VISIT_TYPE { get; }
        int? WaitTime { get; }
        string WaitTimeFormatted { get; }
        object Parent { get; set; }
        bool IsLocked { get; set; }
        void OnClose();
        ValidationMessage ValidationMessage { get; set; }
        void EnableEventHandlers(bool enable);
    }
}
