using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

using Microsoft.Practices.Composite.Presentation.Commands;

using ClinSchd.Infrastructure.Models;
using ClinSchd.Modules.VAR.Controllers;
using ClinSchd.Modules.VAR.Models;

namespace ClinSchd.Modules.VAR.VAR
{
	public interface IVARPresentationModel
    {
		IVARView View { get; }
		ValidationMessage ValidationMessage { get; set; }

        DelegateCommand<string> CloseCommand { get; }
//        DelegateCommand<string> RequestApprovedCommand { get; }
//        DelegateCommand<string> RequestNotAvailableCommand { get; }
        DelegateCommand<string> RequestSelectedCommand { get; }

        ObservableCollection<AppointmentRequestItemPresentationModel> MobileRequestList { get; set; }
        AppointmentRequestItemPresentationModel SelectedMobileRequest { get; set; }
        string VARRequestCountDisplay { get; }

        List<string> WaitTimeValues { get; }
        string WaitTimeValue { get; set; }

        void OnClose ();

	}
}
