﻿using System.Windows;
using System.Windows.Input;
using ClinSchd.Infrastructure;

namespace ClinSchd.Modules.VAR.VAR
{
    /// <summary>
    /// Interaction logic for VARDetailView.xaml
    /// </summary>
    public partial class VARDetailView : Window, IVARDetailView
    {
        public VARDetailView()
        {
            InitializeComponent();
        }

        public IAppointmentRequestItemPresentationModel Model
        {
            get
            {
                return this.DataContext as AppointmentRequestItemPresentationModel;
            }

            set
            {
                this.DataContext = value;
                this.Owner = (Window)value.Parent;
                value.View = this;
            }
        }

        private bool bDialogResult;
        public bool ConfirmUser(string message, string caption)
        {
            bDialogResult = Infrastructure.Keys.ConfirmUser(this, message, caption);
            return bDialogResult;
        }

        public void AlertUser(string message, string caption)
        {
            Infrastructure.Keys.AlertUser(this, message, caption);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Keys.SetRenderingMode(this);
            MoveFocus(new TraversalRequest(FocusNavigationDirection.Next));
        }

        private void HotKeyHandler(object sender, KeyEventArgs e)
        {
            if (Keyboard.Modifiers == ModifierKeys.Alt)
            {
                Key key = e.Key == Key.System ? e.SystemKey : e.Key;
                switch (key)
                {
                    case Key.B:
                        Keyboard.Focus(BookedButton);
                        break;
                    case Key.C:
                        Keyboard.Focus(CancelButton);
                        break;
                    case Key.N:
                        Keyboard.Focus(NotBookedButton);
                        break;
                }
            }
        }

        public void SetFocus()
        {
            Focus();
            Keyboard.Focus(this);
        }
    }
}
