﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Animation;

namespace ClinSchd.InactivityTimeout
{
    /// <summary>
    /// Interaction logic for CountDownView.xaml
    /// </summary>
    public partial class CountDownView : Window
    {
        #region Fields

        private int _countdownSeconds = 0;

        #endregion Fields

        #region constructor

        public CountDownView(int countdownSeconds)
        {
            InitializeComponent();
            _countdownSeconds = countdownSeconds;            
        }

        #endregion constructor

        #region private methods

        private void CloseDialog(bool dialogResult)
        {
            countDown.Stop();
            this.DialogResult = dialogResult;
            this.Close();
        }

/*        private void StartCountdown(FrameworkElement target)
        {
            _countdownInProgress = true;
            var countdownAnimation = new StringAnimationUsingKeyFrames();

            for (var i = _countdownSeconds; i > 0; i--)
            {
                var keyTime = TimeSpan.FromSeconds(_countdownSeconds - i);
                string secondsDisplay = ((i == 1) ? "second" : "seconds");
                var frame = new DiscreteStringKeyFrame(String.Format("{0} {1}", i.ToString(), secondsDisplay), KeyTime.FromTimeSpan(keyTime));
                countdownAnimation.KeyFrames.Add(frame);
            }
            countdownAnimation.KeyFrames.Add(new DiscreteStringKeyFrame(" ", KeyTime.FromTimeSpan(TimeSpan.FromSeconds(6))));
            Storyboard.SetTargetName(countdownAnimation, target.Name);
            Storyboard.SetTargetProperty(countdownAnimation, new PropertyPath(TextBlock.TextProperty));

            var countdownStoryboard = new Storyboard();
            countdownStoryboard.Children.Add(countdownAnimation);
            countdownStoryboard.Completed += CountdownTimer_Completed;
            countdownStoryboard.Begin(this);
        }
*/

        #endregion private methods

        #region event handlers

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            CloseDialog(false);
        }

        private void CountdownTimer_Completed(object sender, EventArgs e)
        {
            CloseDialog(false);
        }

        private void SubmitButton_Click(object sender, RoutedEventArgs e)
        {
            CloseDialog(true);
        }

        private void Window_Activated(object sender, EventArgs e)
        {
            if (!countDown.IsRunning)
                countDown.Start(TimeSpan.FromSeconds(_countdownSeconds));
        }

        #endregion event handlers
    }
}
